	.module accel.c
	.dbfile accel.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; #include <transam.h>
; 
; int Accelerator(int);
; 
; int Accelerator(int speed)
; {
; 	int L_Speed, R_Speed;
; 	 
; 	int current_speed = 0;
; 	
; 	if (speed <= 0)
; 	{
; 		if (speed <= -5)
; 		{
; 			L_Speed = -99;
; 			R_Speed = 4;
; 		}
; 		else if (speed <= -4)
; 		{
; 			L_Speed = -90;
; 			R_Speed = 14;
; 		}
; 		else if (speed <= -3)	
; 		{
; 			L_Speed = -80;
; 			R_Speed = 24;
; 			//perfect
; 		}
; 		else if (speed <= -2)
; 		{
; 			L_Speed = -70;
; 			R_Speed = 34;
; 			//near perfect
; 		}
; 		else if (speed <= -1)
; 		{
; 			L_Speed = -62;
; 			R_Speed = 44;
; 		}
; 		else if (speed <= 0)
; 		{
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 			L_Speed = 0;
; 			R_Speed = 0;
; 		}
; 	}
; 	else if (speed > 0)
; 	{
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 		if (speed >= 5)
; 		{
; 			L_Speed = -6;
; 			R_Speed = 99;
; 		}
; 		else if (speed >= 4)
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 		{
; 			L_Speed = -11;
; 			R_Speed = 94;
; 		}
; 		else if (speed >= 3)
; 		{
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 			L_Speed = -19;
; 			R_Speed = 84;
; 		}
; 		else if (speed >= 2)
; 		{
; 			L_Speed = -29;
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 			R_Speed = 74;
; 		}
; 		else if (speed >= 1)
; 		{
; 			L_Speed = -41;
; 			R_Speed = 64;
; 		}
; 		
; 	}
; 	else
; 	{
; 			L_Speed = 0;
; 			R_Speed = 0;
; 	}		
; 
; 	
;  if (speed < current_speed)
; 	{
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 		BrakeLight;
; 	}
; 	else 
; 		NoSignal;
; 		
; 	motorp(0, L_Speed);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 	motorp(1, R_Speed);
; 
; 	return current_speed;
; }
; }
; }
; }
; }
; }
; }
; }
; }
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; }
; }
; }
; }
; }
; }
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; }
; }
; }
; }
; }
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;  current_speed -> 6,x
;          speed -> 10,x
_Accelerator::
	jsr __enterb
	.byte 0x48
	.dbfile accel.c
	.dbfunc Accelerator
	.dbline 9
	ldd #0
	std 6,x
	.dbline 11
	ldd 10,x
	ble X0
	jmp L20
X0:
	.dbline 13
	ldd 10,x
	cpd #-5
	bgt L22
	.dbline 15
	ldd #-99
	std 4,x
	.dbline 16
	ldd #4
	std 2,x
	.dbline 17
	jmp L21
L22:
	.dbline 18
	ldd 10,x
	cpd #-4
	bgt L24
	.dbline 20
	ldd #-90
	std 4,x
	.dbline 21
	ldd #14
	std 2,x
	.dbline 22
	jmp L21
L24:
	.dbline 23
	ldd 10,x
	cpd #-3
	bgt L26
	.dbline 25
	ldd #-80
	std 4,x
	.dbline 26
	ldd #24
	std 2,x
	.dbline 28
	jmp L21
L26:
	.dbline 29
	ldd 10,x
	cpd #-2
	bgt L28
	.dbline 31
	ldd #-70
	std 4,x
	.dbline 32
	ldd #34
	std 2,x
	.dbline 34
	jmp L21
L28:
	.dbline 35
	ldd 10,x
	cpd #-1
	bgt L30
	.dbline 37
	ldd #-62
	std 4,x
	.dbline 38
	ldd #44
	std 2,x
	.dbline 39
	jmp L21
L30:
	.dbline 40
	ldd 10,x
	ble X1
	jmp L21
X1:
	.dbline 42
	ldd #0
	std 4,x
	.dbline 43
	ldd #0
	std 2,x
	.dbline 45
	jmp L21
L20:
	.dbline 46
	ldd 10,x
	bgt X2
	jmp L34
X2:
	.dbline 48
	ldd 10,x
	cpd #5
	blt L36
	.dbline 50
	ldd #-6
	std 4,x
	.dbline 51
	ldd #99
	std 2,x
	.dbline 52
	bra L35
L36:
	.dbline 53
	ldd 10,x
	cpd #4
	blt L38
	.dbline 55
	ldd #-11
	std 4,x
	.dbline 56
	ldd #94
	std 2,x
	.dbline 57
	bra L35
L38:
	.dbline 58
	ldd 10,x
	cpd #3
	blt L40
	.dbline 60
	ldd #-19
	std 4,x
	.dbline 61
	ldd #84
	std 2,x
	.dbline 62
	bra L35
L40:
	.dbline 63
	ldd 10,x
	cpd #2
	blt L42
	.dbline 65
	ldd #-29
	std 4,x
	.dbline 66
	ldd #74
	std 2,x
	.dbline 67
	bra L35
L42:
	.dbline 68
	ldd 10,x
	cpd #1
	blt L35
	.dbline 70
	ldd #-41
	std 4,x
	.dbline 71
	ldd #64
	std 2,x
	.dbline 74
	bra L35
L34:
	.dbline 77
	ldd #0
	std 4,x
	.dbline 78
	ldd #0
	std 2,x
	.dbline 79
L35:
L21:
	.dbline 82
	ldd 10,x
	cpd 6,x
	bge L46
	.dbline 84
	ldab #15
	stab 0x6000
	.dbline 85
	bra L47
L46:
	.dbline 87
	ldab #11
	stab 0x6000
L47:
	.dbline 89
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 90
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 92
	ldd 6,x
L19:
	xgdx
	addd #8
	xgdx
	txs
	pulx
	puly
	rts
	.area bss
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
