	.module ir_test.c
	.dbfile ir_test.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /*
; * Title        ir_test.c
; * Programmers  Jason W. Grzywna	
; * Date         March 24, 2000
; * Version      1
; 
; * Description 
; This program outputs the values of the IR detectors and the bumper switches
; continuously. This program lets you test the basic sensor suite of the
; TJ Pro robot.
; 
; Serial Protocol of this program:
;   baud=9600, 8 data bits, 1 stop bit, no parity, no flow control.
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; 
; /***************************** Main **********************************/
; void main(void)
; {
; 
; /* VT100 clear screen */ 
;   char clear[]= "\x1b\x5B\x32\x4A\x04"; 
; 
; /* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
;   char place[]= "\x1b[1;1H";	/*Home*/	
; 
;   init_analog();
;   init_clocktjp();
;   init_serial();
; 
;   SET_BIT(DDRD, 0x1C);
;   SET_BIT(PORTD, 0x0C);
;   
; 
;   IRE_ON; /*turn on IR emitters */
; 
;   printf("%s", clear);  
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
;   printf("%s", place);
;   
;   printf("\tTitle\t\tsensetjp.c\n"
;   "\tProgrammer\tKeith L. Doty\n"
;   "\tDate\t\tSeptember, 1998\n"
;   "\tVersion\t\t1\n\n");
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 
;   printf("TALRIK JUNIOR PROFESSIONAL SENSOR READINGS\n\n");
;   printf("Left IR    Right IR    Bumper\n"); 
; 
;   while(1)
;   {
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 
;   /*
;     Move cursor to data field position and print data
;     The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
;   */
;     printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
;     printf("\x1b[10;13H   \b\b\b\b%d",RIGHT_IR);
;     printf("\x1b[10;25H   \b\b\b\b%d",BUMPER);
;     wait(50);
; 
;   }/*end while(1)*/
; }
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
; /***************************** End of Main **********************************/
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
L20:
	.byte 27,91,50,'J,4,0
L21:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;          place -> 3,x
;          clear -> 10,x
_main::
	jsr __enterb
	.byte 0x10
	.dbfile ir_test.c
	.dbfunc main
	.dbline 26
	ldd 0,x
	addd #10
	ldy #L20
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 29
	ldd 0,x
	addd #3
	ldy #L21
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 31
	jsr _init_analog
	.dbline 32
	jsr _init_clocktjp
	.dbline 33
	jsr _init_serial
	.dbline 35
	ldy #0x1009
	bset 0,y,#28
	.dbline 36
	ldy #0x1008
	bset 0,y,#12
	.dbline 39
	ldab #7
	stab 0x7000
	.dbline 41
	ldd 0,x
	addd #10
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 42
	ldd 0,x
	addd #3
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 44
	ldd #L23
	jsr _printf
	.dbline 49
	ldd #L24
	jsr _printf
	.dbline 50
	ldd #L25
	jsr _printf
	bra L27
L26:
	.dbline 59
	ldd #3
	jsr _analog
	pshb
	psha
	ldd #L29
	jsr _printf
	puly
	.dbline 60
	ldd #2
	jsr _analog
	pshb
	psha
	ldd #L30
	jsr _printf
	puly
	.dbline 61
	ldd #0
	jsr _analog
	pshb
	psha
	ldd #L31
	jsr _printf
	puly
	.dbline 62
	ldd #50
	jsr _wait
	.dbline 64
L27:
	.dbline 52
	bra L26
L19:
	xgdx
	addd #16
	xgdx
	txs
	pulx
	rts
	.area bss
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L31:
	.byte 27,91,49,48,59,50,53,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L30:
	.byte 27,91,49,48,59,49,51,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L29:
	.byte 27,91,49,48,59,49,'H,32,32,32,32,8,8,8,8,8
	.byte 37,'d,0
L25:
	.byte 'L,'e,'f,'t,32,'I,'R,32,32,32,32,'R,'i,'g,'h,'t
	.byte 32,'I,'R,32,32,32,32,'B,'u,'m,'p,'e,'r,10,0
L24:
	.byte 'T,'A,'L,'R,'I,'K,32,'J,'U,'N,'I,'O,'R,32,'P,'R
	.byte 'O,'F,'E,'S,'S,'I,'O,'N,'A,'L,32,'S,'E,'N,'S,'O
	.byte 'R,32,'R,'E,'A,'D,'I,'N,'G,'S,10,10,0
L23:
	.byte 9,'T,'i,'t,'l,'e,9,9,'s,'e,'n,'s,'e,'t,'j,'p
	.byte 46,'c,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9,'K
	.byte 'e,'i,'t,'h,32,'L,46,32,'D,'o,'t,'y,10,9,'D,'a
	.byte 't,'e,9,9,'S,'e,'p,'t,'e,'m,'b,'e,'r,44,32,49
	.byte 57,57,56,10,9,'V,'e,'r,'s,'i,'o,'n,9,9,49,10
	.byte 10,0
L22:
	.byte 37,'s,0
