	.module track_g2.c
	.dbfile track_g2.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; #include <transam.h>
; #include <stdio.h>
; 
; void off_track();
; void on_track();
; int IR_procT();
; int CDS_procT();
; int Accelerator(int);
; void turn(int);
; void turn_toward_ir();
; 
; int on_track_yes = 0;
; int current_lane = 0;
; int current_speed = 0;
; int velocity, i, j, k;
; int H_nose_min, H_L_min, H_R_min;
; int L_nose_min, L_L_min, L_R_min;
; int left_temp;
; int right_temp;
; int nosej;
; 
; H_L_min = 220;
; H_R_min = 180;
; H_nose_min = 170;
; 
; L_L_min = 200;
; L_R_min = 175;
; L_nose_min = 165;
; 
; void main(void)
; {
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	NoSignal;
; 	START;
; 	IRE_ON;
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 	while(1)
; 	{
; 		//printf("\n%d", on_track_yes);	
; 		if (on_track_yes > 0)
; 		{
; 			on_track();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 		}
; 		else 
; 			off_track();
; 	
; 	}
; }
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 
; void on_track()
; {
; 	int temptrack, z, noseO, left_cdsO, right_cdsO;
; 	int avoidance_ir;
; 
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 	noseO 		= analog(1);
; 	left_cdsO 	= analog(5);
; 	right_cdsO	= analog(6);
; 	
; 	temptrack = CDS_procT();
; 	turn(temptrack);
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 	velocity = Accelerator(-3);
; 	
; 	if ((noseO <= 150) && (left_cdsO <= 170) && (right_cdsO <= 160))
; 	{
; 		z++;
; 	}
; 	else if ((noseO >= 170) || (left_cdsO >= 175) || (right_cdsO >= 165))
; 	{
; 		z = 0;
; 	}
; 	
; 	if (z >= 10)
; 	{
; 		on_track_yes = 0;
; 	}
; 	
; 	avoidance_ir = IR_procT();
; 	
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	if ((avoidance_ir > 0) || (avoidance_ir < 0))
; 	{
; 		if (current_lane == 1)
; 		{
; 			turn(3);
; 			wait(350);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 			on_track_yes = 0;
; 		}
; 		else if (current_lane == 2)
; 		{
; 			turn(-3);
; 			wait(350);
; 			on_track_yes = 0;
; 		}
; 	
; 	}
; 	
; 	
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; }
; 
; 
; void off_track()
; {
; 	int turning_IR, nose, left_cds, right_cds;
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	
; 	turning_IR = IR_procT();
; 	turn(turning_IR);
; 	velocity = Accelerator(-3);
; 	current_lane = 0;
; 	
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 	if (FRONT_BUMP)
; 	{
; 		Accelerator(4);
; 		turn_toward_ir();
; 		wait(800);
; 	}
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 	
; 	nose 			= analog(1);
; 	left_cds 	= analog(5);
; 	right_cds	= analog(6);
; 		
; 	if (nose > 170)
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 	{
; 	
; 	//HazardSignal;
; 	
; 	Accelerator(-1);
; 	
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	for ( i = 0; i < 1000; i++)
; 	{
; 		//printf("\tleft: %d", left_cds);
; 		//printf("\tright: %d", right_cds);
; 		//printf("\tnose: %d\n", nose);
; 					
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 		left_temp = analog(5);
; 		right_temp = analog(6);
; 		
; 		if (left_temp > 175)
; 		{
; 			//printf("see left");
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 			j = 0;
; 			while ((nosej <= 175) && (j <= 250))
; 			{
; 				//printf("\nJ= %d", j);
; 				//printf("\nNoseJ= %d", nosej); 
; 				nosej = analog(1);
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 				turn(3);
; 				j++;
; 			}
; 			
; 			if (nosej > 175)
; 					{
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_on_track_yes::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_lane::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_speed::
	.blkb 2
	.area idata
	.word 0
	.area data
_H_L_min::
	.blkb 2
	.area idata
	.word 220
	.area data
_H_R_min::
	.blkb 2
	.area idata
	.word 180
	.area data
_H_nose_min::
	.blkb 2
	.area idata
	.word 170
	.area data
_L_L_min::
	.blkb 2
	.area idata
	.word 200
	.area data
_L_R_min::
	.blkb 2
	.area idata
	.word 175
	.area data
_L_nose_min::
	.blkb 2
	.area idata
	.word 165
	.area text
;  IX -> 0,x
_main::
	.dbfile track_g2.c
	.dbfunc main
	.dbline 33
	jsr _init_analog
	.dbline 34
	jsr _init_motortjp
	.dbline 35
	jsr _init_clocktjp
	.dbline 36
	jsr _init_servotjp
	.dbline 38
	ldab #11
	stab 0x6000
L20:
	.dbline 39
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 40
	ldab #7
	stab 0x7000
	bra L24
L23:
	.dbline 45
	ldd _on_track_yes
	ble L26
	.dbline 47
	jsr _on_track
	.dbline 48
	bra L27
L26:
	.dbline 50
	jsr _off_track
L27:
	.dbline 52
L24:
	.dbline 42
	bra L23
L19:
	rts
;  IX -> 0,x
;              z -> 2,x
;      temptrack -> 4,x
;     right_cdsO -> 6,x
;      left_cdsO -> 8,x
;          noseO -> 10,x
;   avoidance_ir -> 12,x
_on_track::
	jsr __enterb
	.byte 0xe
	.dbfunc on_track
	.dbline 60
	ldd #1
	jsr _analog
	std 10,x
	.dbline 61
	ldd #5
	jsr _analog
	std 8,x
	.dbline 62
	ldd #6
	jsr _analog
	std 6,x
	.dbline 64
	jsr _CDS_procT
	std 4,x
	.dbline 65
	ldd 4,x
	jsr _turn
	.dbline 66
	ldd #-3
	jsr _Accelerator
	std _velocity
	.dbline 68
	ldd 10,x
	cpd #150
	bgt L29
	ldd 8,x
	cpd #170
	bgt L29
	ldd 6,x
	cpd #160
	bgt L29
	.dbline 70
	ldd 2,x
	addd #1
	std 2,x
	.dbline 71
	bra L30
L29:
	.dbline 72
	ldd 10,x
	cpd #170
	bge L34
	ldd 8,x
	cpd #175
	bge L34
	ldd 6,x
	cpd #165
	blt L31
L34:
	.dbline 74
	ldd #0
	std 2,x
	.dbline 75
L31:
L30:
	.dbline 77
	ldd 2,x
	cpd #10
	blt L35
	.dbline 79
	ldd #0
	std _on_track_yes
	.dbline 80
L35:
	.dbline 82
	jsr _IR_procT
	std 12,x
	.dbline 84
	ldd 12,x
	bgt L39
	ldd 12,x
	bge L37
L39:
	.dbline 86
	ldd _current_lane
	cpd #1
	bne L40
	.dbline 88
	ldd #3
	jsr _turn
	.dbline 89
	ldd #350
	jsr _wait
	.dbline 90
	ldd #0
	std _on_track_yes
	.dbline 91
	bra L41
L40:
	.dbline 92
	ldd _current_lane
	cpd #2
	bne L42
	.dbline 94
	ldd #-3
	jsr _turn
	.dbline 95
	ldd #350
	jsr _wait
	.dbline 96
	ldd #0
	std _on_track_yes
	.dbline 97
L42:
L41:
	.dbline 99
L37:
	.dbline 102
L28:
	xgdx
	addd #14
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;      right_cds -> 2,x
;       left_cds -> 4,x
;           nose -> 6,x
;     turning_IR -> 8,x
_off_track::
	jsr __enterb
	.byte 0xa
	.dbfunc off_track
	.dbline 109
	jsr _IR_procT
	std 8,x
	.dbline 110
	ldd 8,x
	jsr _turn
	.dbline 111
	ldd #-3
	jsr _Accelerator
	std _velocity
	.dbline 112
	ldd #0
	std _current_lane
	.dbline 114
	ldd #0
	jsr _analog
	cpd #10
	ble L45
	ldd #0
	jsr _analog
	cpd #120
	bge L45
	.dbline 116
	ldd #4
	jsr _Accelerator
	.dbline 117
	jsr _turn_toward_ir
	.dbline 118
	ldd #800
	jsr _wait
	.dbline 119
L45:
	.dbline 121
	ldd #1
	jsr _analog
	std 6,x
	.dbline 122
	ldd #5
	jsr _analog
	std 4,x
	.dbline 123
	ldd #6
	jsr _analog
	std 2,x
	.dbline 125
	ldd 6,x
	cpd #170
	bgt X0
	jmp L47
X0:
	.dbline 130
	ldd #-1
	jsr _Accelerator
	.dbline 132
	ldd #0
	std _i
L49:
	.dbline 138
	ldd #5
	jsr _analog
	std _left_temp
	.dbline 139
	ldd #6
	jsr _analog
	std _right_temp
	.dbline 141
	ldd _left_temp
	cpd #175
	ble L53
	.dbline 144
	ldd #0
	std _j
	bra L56
L55:
	.dbline 149
	ldd #1
	jsr _analog
	std _nosej
	.dbline 150
	ldd #3
	jsr _turn
	.dbline 151
	ldd _j
	addd #1
	std _j
	.dbline 152
L56:
	.dbline 145
	ldd _nosej
	cpd #175
	bgt L58
	ldd _j
	cpd #250
	ble L55
L58:
	.dbline 154
	ldd _nosej
	cpd #175
	ble L54
	.dbline 156
; 						on_track_yes = 1;
	ldd #1
	std _on_track_yes
	.dbline 157
; 						current_lane = current_lane + 1;
	ldd _current_lane
	addd #1
	std _current_lane
	.dbline 158
; 						break;
	bra L51
L53:
	.dbline 162
; 					}
; 					
; 		}
; 		else if (right_temp > 160)
	ldd _right_temp
	cpd #160
	ble L61
	.dbline 165
; 		{
; 			//printf("see right");
; 			k = 0;
	ldd #0
	std _k
	bra L64
L63:
	.dbline 168
	ldd #1
	jsr _analog
	std _nosej
	.dbline 172
	ldd #-3
	jsr _turn
	.dbline 173
	ldd _k
	addd #1
	std _k
	.dbline 174
L64:
	.dbline 166
; 			while ((nosej <= 175) && (k <= 250))
	ldd _nosej
	cpd #175
	bgt L66
	ldd _k
	cpd #250
	ble L63
L66:
	.dbline 176
; 			{
; 				nosej = analog(1);
; 				//printf("\t\nNoseJ= %d", nosej);
; 				//printf("\t\nK= %d", k);
; 				
; 				turn(-3);
; 				k++;
; 			}
; 			
; 			if (nosej > 175)
	ldd _nosej
	cpd #175
	ble L67
	.dbline 178
; 			{
; 				on_track_yes = 1;
	ldd #1
	std _on_track_yes
	.dbline 179
; 				current_lane = current_lane + 1;
	ldd _current_lane
	addd #1
	std _current_lane
	.dbline 180
; 				break;
	bra L51
L67:
	.dbline 182
; 			}
; 		}
L61:
L54:
	.dbline 183
; 	}
L50:
	ldd _i
	addd #1
	std _i
	cpd #1000
	bge X1
	jmp L49
X1:
L51:
	.dbline 184
; 	}
L47:
	.dbline 185
; }
L44:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         C_nose -> 2,x
;        C_right -> 4,x
;         C_left -> 6,x
;            XYZ -> 8,x
_CDS_procT::
	jsr __enterb
	.byte 0xa
	.dbfunc CDS_procT
	.dbline 192
; 	
; int CDS_procT()
; {
; 
; 	int C_left, C_right, C_nose, XYZ;
; 		
; 	C_left 	= analog(5);
	ldd #5
	jsr _analog
	std 6,x
	.dbline 193
; 	C_right  = analog(6);
	ldd #6
	jsr _analog
	std 4,x
	.dbline 194
; 	C_nose	= analog(1);
	ldd #1
	jsr _analog
	std 2,x
	.dbline 196
; 	
; 	XYZ = 0;
	ldd #0
	std 8,x
	.dbline 199
; 	
; 	//if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
; 	if ((C_left < L_L_min) && (C_right < L_R_min) && (C_nose < L_nose_min))
	ldd 6,x
	cpd _L_L_min
	bge L70
	ldd 4,x
	cpd _L_R_min
	bge L70
	ldd 2,x
	cpd _L_nose_min
	bge L70
	.dbline 201
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 202
; 	}
	bra L71
L70:
	.dbline 203
; 	else if (C_left > L_L_min)
	ldd 6,x
	cpd _L_L_min
	ble L72
	.dbline 205
; 	{
; 		XYZ = -3;
	ldd #-3
	std 8,x
	.dbline 206
; 	}
	bra L73
L72:
	.dbline 207
; 	else if (C_right > L_R_min)
	ldd 4,x
	cpd _L_R_min
	ble L74
	.dbline 209
; 	{
; 		XYZ = 3;
	ldd #3
	std 8,x
	.dbline 210
; 	}
	bra L75
L74:
	.dbline 211
; 	else if (C_nose > L_nose_min)
	ldd 2,x
	cpd _L_nose_min
	ble L76
	.dbline 213
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 214
; 	}
	bra L77
L76:
	.dbline 216
; 	//else if ((C_left < 225) && (C_right < 215))
; 	else if ((C_left < L_L_min) && (C_right < L_R_min))
	ldd 6,x
	cpd _L_L_min
	bge L78
	ldd 4,x
	cpd _L_R_min
	bge L78
	.dbline 218
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 219
; 	}
L78:
L77:
L75:
L73:
L71:
	.dbline 221
; 	
; 	return XYZ;
	ldd 8,x
L69:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 228
; }
; 
; void turn(int dot)
; {
; 	int degree;
; 	
; 	if (dot < 0)
	ldd 6,x
	bge L81
	.dbline 230
; 	{
; 		if (dot <= -3)
	ldd 6,x
	cpd #-3
	bgt L83
	.dbline 232
; 		{
; 			degree = 1500;
	ldd #1500
	std 2,x
	.dbline 233
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 235
; 			
; 		}
	jmp L82
L83:
	.dbline 236
; 		else if (dot <= -2)
	ldd 6,x
	cpd #-2
	bgt L85
	.dbline 238
; 		{
; 			degree = 1834;
	ldd #1834
	std 2,x
	.dbline 239
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 241
; 			
; 		}
	bra L82
L85:
	.dbline 242
; 		else if (dot <= -1)
	ldd 6,x
	cpd #-1
	bgt L82
	.dbline 244
; 		{
; 			degree = 2167;
	ldd #2167
	std 2,x
	.dbline 245
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 248
; 			
; 		}
; 	}
	bra L82
L81:
	.dbline 249
; 	else if (dot > 0)
	ldd 6,x
	ble L89
	.dbline 251
; 	{
; 		if (dot >= 3)
	ldd 6,x
	cpd #3
	blt L91
	.dbline 253
; 		{
; 			degree = 4000;
	ldd #4000
	std 2,x
	.dbline 254
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 256
; 			
; 		}
	bra L90
L91:
	.dbline 257
; 		else if (dot >= 2)
	ldd 6,x
	cpd #2
	blt L93
	.dbline 259
; 		{
; 			degree = 3500;
	ldd #3500
	std 2,x
	.dbline 260
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 262
; 			
; 		}
	bra L90
L93:
	.dbline 263
; 		else if (dot >= 1)
	ldd 6,x
	cpd #1
	blt L90
	.dbline 265
; 		{
; 			degree = 3000;
	ldd #3000
	std 2,x
	.dbline 266
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 269
; 			
; 		}
; 	}
	bra L90
L89:
	.dbline 272
; 	else
; 	{
; 		degree = 2500;
	ldd #2500
	std 2,x
	.dbline 273
; 		NoSignal;
	ldab #11
	stab 0x6000
	.dbline 274
; 	}
L90:
L82:
	.dbline 276
; 	
; 	servo(0, degree);
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 277
; 	wait(100);	
	ldd #100
	jsr _wait
	.dbline 279
; 
; }	
L80:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         t_diff -> 2,x
;          irT_R -> 4,x
;          irT_L -> 6,x
;             tR -> 8,x
;             tL -> 10,x
_IR_procT::
	jsr __enterb
	.byte 0xc
	.dbfunc IR_procT
	.dbline 285
; 
; int IR_procT()
; {
; 
; int irT_L, irT_R, t_diff;
; int tL = 0;
	ldd #0
	std 10,x
	.dbline 286
; int tR = 0;
	ldd #0
	std 8,x
	.dbline 287
; irT_L = analog(3);
	ldd #3
	jsr _analog
	std 6,x
	.dbline 288
; irT_R = analog(2);
	ldd #2
	jsr _analog
	std 4,x
	.dbline 294
; 
; //printf("\t%d\n", irT_L);
; //printf("\t\t%d\n", irT_R);
; 
; 
; if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L98
	.dbline 296
; {
; 	if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L99
	.dbline 298
; 	{
; 		tL = 1;
	ldd #1
	std 10,x
	.dbline 299
; 		if (irT_L > 105)
	ldd 6,x
	cpd #105
	ble L99
	.dbline 301
; 		{
; 			tL = tL + 1;	
	ldd 10,x
	addd #1
	std 10,x
	.dbline 302
; 			if (irT_L > 115)
	ldd 6,x
	cpd #115
	ble L99
	.dbline 304
; 			{
; 				tL = tL + 1;
	ldd 10,x
	addd #1
	std 10,x
	.dbline 308
; 			}
; 		}
; 	}
; }
	bra L99
L98:
	.dbline 311
; else
; 	{
; 		tL = 0;
	ldd #0
	std 10,x
	.dbline 312
; 	}	
L99:
	.dbline 315
; 
; 
; if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L106
	.dbline 318
; {
; 
; 	if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L107
	.dbline 320
; 	{
; 		tR = 1;
	ldd #1
	std 8,x
	.dbline 321
; 		if (irT_R > 105)
	ldd 4,x
	cpd #105
	ble L107
	.dbline 323
; 		{
; 			tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 324
; 			if (irT_R > 115)
	ldd 4,x
	cpd #115
	ble L107
	.dbline 326
; 			{
; 				tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 330
; 			}	
; 		}
; 	}
; }	
	bra L107
L106:
	.dbline 333
; else 
; 	{
; 		tR = 0;
	ldd #0
	std 8,x
	.dbline 334
; 	}	
L107:
	.dbline 336
; 
; t_diff = tL - tR;
	ldd 10,x
	subd 8,x
	std 2,x
	.dbline 345
; 
; //printf ("\ntL=%d\t", tL);
; //printf ("tR=%d\t", tR);
; //printf ("t_diff=%d", t_diff);
; 
; //if ( tL = tR )
; //	return tR;
; //else 
; 	return t_diff;
	ldd 2,x
L97:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;          speed -> 8,x
_Accelerator::
	jsr __enterb
	.byte 0x46
	.dbfunc Accelerator
	.dbline 357
; 	
; }
; 
; 
; int Accelerator(int speed)
; {
; 	
; 	int L_Speed, R_Speed;
; 	 
; 	
; 	
; 	if (speed <= 0)
	ldd 8,x
	ble X2
	jmp L115
X2:
	.dbline 359
; 	{
; 		if (speed <= -5)
	ldd 8,x
	cpd #-5
	bgt L117
	.dbline 361
; 		{
; 			L_Speed = -99;
	ldd #-99
	std 4,x
	.dbline 362
; 			R_Speed = 4;
	ldd #4
	std 2,x
	.dbline 363
; 		}
	jmp L116
L117:
	.dbline 364
; 		else if (speed <= -4)
	ldd 8,x
	cpd #-4
	bgt L119
	.dbline 366
; 		{
; 			L_Speed = -90;
	ldd #-90
	std 4,x
	.dbline 367
; 			R_Speed = 14;
	ldd #14
	std 2,x
	.dbline 368
; 		}
	jmp L116
L119:
	.dbline 369
; 		else if (speed <= -3)	
	ldd 8,x
	cpd #-3
	bgt L121
	.dbline 371
; 		{
; 			L_Speed = -80;
	ldd #-80
	std 4,x
	.dbline 372
; 			R_Speed = 24;
	ldd #24
	std 2,x
	.dbline 374
; 			//perfect
; 		}
	jmp L116
L121:
	.dbline 375
; 		else if (speed <= -2)
	ldd 8,x
	cpd #-2
	bgt L123
	.dbline 377
; 		{
; 			L_Speed = -70;
	ldd #-70
	std 4,x
	.dbline 378
; 			R_Speed = 34;
	ldd #34
	std 2,x
	.dbline 380
; 			//near perfect
; 		}
	jmp L116
L123:
	.dbline 381
; 		else if (speed <= -1)
	ldd 8,x
	cpd #-1
	bgt L125
	.dbline 383
; 		{
; 			L_Speed = -62;
	ldd #-62
	std 4,x
	.dbline 384
; 			R_Speed = 44;
	ldd #44
	std 2,x
	.dbline 385
; 		}
	jmp L116
L125:
	.dbline 386
; 		else if (speed <= 0)
	ldd 8,x
	ble X3
	jmp L116
X3:
	.dbline 388
; 		{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 389
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 391
; 		}
; 	}
	jmp L116
L115:
	.dbline 392
; 	else if (speed > 0)
	ldd 8,x
	bgt X4
	jmp L129
X4:
	.dbline 394
; 	{
; 		if (speed >= 5)
	ldd 8,x
	cpd #5
	blt L131
	.dbline 396
; 		{
; 			L_Speed = -6;
	ldd #-6
	std 4,x
	.dbline 397
; 			R_Speed = 99;
	ldd #99
	std 2,x
	.dbline 398
; 		}
	bra L130
L131:
	.dbline 399
; 		else if (speed >= 4)
	ldd 8,x
	cpd #4
	blt L133
	.dbline 401
; 		{
; 			L_Speed = -11;
	ldd #-11
	std 4,x
	.dbline 402
; 			R_Speed = 94;
	ldd #94
	std 2,x
	.dbline 403
; 		}
	bra L130
L133:
	.dbline 404
; 		else if (speed >= 3)
	ldd 8,x
	cpd #3
	blt L135
	.dbline 406
; 		{
; 			L_Speed = -19;
	ldd #-19
	std 4,x
	.dbline 407
; 			R_Speed = 84;
	ldd #84
	std 2,x
	.dbline 408
; 		}
	bra L130
L135:
	.dbline 409
; 		else if (speed >= 2)
	ldd 8,x
	cpd #2
	blt L137
	.dbline 411
; 		{
; 			L_Speed = -29;
	ldd #-29
	std 4,x
	.dbline 412
; 			R_Speed = 74;
	ldd #74
	std 2,x
	.dbline 413
; 		}
	bra L130
L137:
	.dbline 414
; 		else if (speed >= 1)
	ldd 8,x
	cpd #1
	blt L130
	.dbline 416
; 		{
; 			L_Speed = -41;
	ldd #-41
	std 4,x
	.dbline 417
; 			R_Speed = 64;
	ldd #64
	std 2,x
	.dbline 420
; 		}
; 		
; 	}
	bra L130
L129:
	.dbline 423
; 	else
; 	{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 424
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 425
; 	}		
L130:
L116:
	.dbline 429
; 
; 	
; 	
; 	if (speed < current_speed)
	ldd 8,x
	cpd _current_speed
	bge L141
	.dbline 431
; 	{
; 		BrakeLight;
	ldab #15
	stab 0x6000
	.dbline 432
; 	}
	bra L142
L141:
	.dbline 434
; 	else 
; 		NoSignal;
	ldab #11
	stab 0x6000
L142:
	.dbline 436
; 		
; 	motorp(0, L_Speed);
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 437
;    motorp(1, R_Speed);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 439
; 
; 	return current_speed;
	ldd _current_speed
L114:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         temp_R -> 2,x
;         temp_L -> 4,x
_turn_toward_ir::
	jsr __enterb
	.byte 0x6
	.dbfunc turn_toward_ir
	.dbline 449
; }
; 
; 
; void turn_toward_ir()
; {
; 
; 	int temp_L;
; 	int temp_R;
; 	
; 	temp_L = analog(3);
	ldd #3
	jsr _analog
	std 4,x
	.dbline 450
; 	temp_R = analog(2);
	ldd #2
	jsr _analog
	std 2,x
	.dbline 452
; 
; 	if (temp_L > temp_R)
	ldd 4,x
	cpd 2,x
	ble L144
	.dbline 454
; 		{
; 			turn(-3);
	ldd #-3
	jsr _turn
	.dbline 456
; 			//printf("-3");
; 		}
	bra L145
L144:
	.dbline 457
; 	else if (temp_R > temp_L)
	ldd 2,x
	cpd 4,x
	ble L146
	.dbline 459
; 		{
; 			turn(3);
	ldd #3
	jsr _turn
	.dbline 461
; 			//printf("3");
; 		}
L146:
L145:
	.dbline 463
; 	
; }
L143:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
	.area bss
_nosej::
	.blkb 2
_right_temp::
	.blkb 2
_left_temp::
	.blkb 2
_k::
	.blkb 2
_j::
	.blkb 2
_i::
	.blkb 2
_velocity::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
