	.module track_g3.c
	.dbfile track_g3.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; #include <transam.h>
; #include <stdio.h>
; 
; void off_track();
; void on_track();
; int IR_procT();
; int CDS_procT();
; int Accelerator(int);
; void turn(int);
; void turn_toward_ir();
; 
; int on_track_yes = 0;
; int current_lane = 0;
; int current_speed = 0;
; int velocity, i, j, k;
; int H_nose_min, H_L_min, H_R_min;
; int L_nose_min, L_L_min, L_R_min;
; int left_temp;
; int right_temp;
; int nosej;
; 
; H_L_min = 220;
; H_R_min = 180;
; H_nose_min = 170;
; 
; L_L_min = 200;
; L_R_min = 175;
; L_nose_min = 165;
; 
; void main(void)
; {
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	NoSignal;
; 	START;
; 	IRE_ON;
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 	while(1)
; 	{
; 		//printf("\n%d", on_track_yes);	
; 		if (on_track_yes > 0)
; 		{
; 			on_track();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 		}
; 		else 
; 			off_track();
; 	
; 	}
; }
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 
; void on_track()
; {
; 	int temptrack, z, noseO, left_cdsO, right_cdsO;
; 	int avoidance_ir;
; 
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 	noseO 		= analog(1);
; 	left_cdsO 	= analog(5);
; 	right_cdsO	= analog(6);
; 	
; 	temptrack = CDS_procT();
; 	turn(temptrack);
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 	velocity = Accelerator(-3);
; 	
; 	if ((noseO <= 150) && (left_cdsO <= 170) && (right_cdsO <= 160))
; 	{
; 		z++;
; 	}
; 	else if ((noseO >= 170) || (left_cdsO >= 175) || (right_cdsO >= 165))
; 	{
; 		z = 0;
; 	}
; 	
; 	if (z >= 10)
; 	{
; 		on_track_yes = 0;
; 	}
; 	
; 	avoidance_ir = IR_procT();
; 	
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	if ((avoidance_ir > 2) || (avoidance_ir < -2))
; 	{
; 		if (current_lane == 1)
; 		{
; 			turn(3);
; 			wait(350);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 			on_track_yes = 0;
; 		}
; 		else if (current_lane == 2)
; 		{
; 			turn(-3);
; 			wait(350);
; 			on_track_yes = 0;
; 		}
; 	
; 	}
; 	
; 	
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; }
; 
; 
; void off_track()
; {
; 	int turning_IR, nose, left_cds, right_cds;
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	
; 	turning_IR = IR_procT();
; 	turn(turning_IR);
; 	velocity = Accelerator(-2);
; 	current_lane = 0;
; 	
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 	if (FRONT_BUMP)
; 	{
; 		Accelerator(4);
; 		turn_toward_ir();
; 		wait(800);
; 	}
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 	
; 	nose 		= analog(1);
; 	left_cds 	= analog(5);
; 	right_cds	= analog(6);
; 		
; 	if (nose > 190)
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 	{
; 	
; 	//HazardSignal;
; 	
; 	Accelerator(-1);
; 	
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	for ( i = 0; i < 3000; i++)
; 	{
; 		//printf("\tleft: %d", left_cds);
; 		//printf("\tright: %d", right_cds);
; 		//printf("\tnose: %d\n", nose);
; 					
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 		left_temp = analog(5);
; 		right_temp = analog(6);
; 		
; 		if (left_temp > 195)
; 		{
; 			//printf("see left");
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 			j = 0;
; 			nosej = analog(1);
; 			while (nosej > 195)
; 			{
; 			nosej = analog(1);
; 			}
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 			while ((nosej <= 195) && (j <= 2500))
; 			{
; 				//printf("\nJ= %d", j);
; 				//printf("\nNoseJ= %d", nosej); 
; 				
; 				
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_on_track_yes::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_lane::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_speed::
	.blkb 2
	.area idata
	.word 0
	.area data
_H_L_min::
	.blkb 2
	.area idata
	.word 220
	.area data
_H_R_min::
	.blkb 2
	.area idata
	.word 180
	.area data
_H_nose_min::
	.blkb 2
	.area idata
	.word 170
	.area data
_L_L_min::
	.blkb 2
	.area idata
	.word 200
	.area data
_L_R_min::
	.blkb 2
	.area idata
	.word 175
	.area data
_L_nose_min::
	.blkb 2
	.area idata
	.word 165
	.area text
;  IX -> 0,x
_main::
	.dbfile track_g3.c
	.dbfunc main
	.dbline 33
	jsr _init_analog
	.dbline 34
	jsr _init_motortjp
	.dbline 35
	jsr _init_clocktjp
	.dbline 36
	jsr _init_servotjp
	.dbline 38
	ldab #11
	stab 0x6000
L20:
	.dbline 39
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 40
	ldab #7
	stab 0x7000
	bra L24
L23:
	.dbline 45
	ldd _on_track_yes
	ble L26
	.dbline 47
	jsr _on_track
	.dbline 48
	bra L27
L26:
	.dbline 50
	jsr _off_track
L27:
	.dbline 52
L24:
	.dbline 42
	bra L23
L19:
	rts
;  IX -> 0,x
;              z -> 2,x
;      temptrack -> 4,x
;     right_cdsO -> 6,x
;      left_cdsO -> 8,x
;          noseO -> 10,x
;   avoidance_ir -> 12,x
_on_track::
	jsr __enterb
	.byte 0xe
	.dbfunc on_track
	.dbline 60
	ldd #1
	jsr _analog
	std 10,x
	.dbline 61
	ldd #5
	jsr _analog
	std 8,x
	.dbline 62
	ldd #6
	jsr _analog
	std 6,x
	.dbline 64
	jsr _CDS_procT
	std 4,x
	.dbline 65
	ldd 4,x
	jsr _turn
	.dbline 66
	ldd #-3
	jsr _Accelerator
	std _velocity
	.dbline 68
	ldd 10,x
	cpd #150
	bgt L29
	ldd 8,x
	cpd #170
	bgt L29
	ldd 6,x
	cpd #160
	bgt L29
	.dbline 70
	ldd 2,x
	addd #1
	std 2,x
	.dbline 71
	bra L30
L29:
	.dbline 72
	ldd 10,x
	cpd #170
	bge L34
	ldd 8,x
	cpd #175
	bge L34
	ldd 6,x
	cpd #165
	blt L31
L34:
	.dbline 74
	ldd #0
	std 2,x
	.dbline 75
L31:
L30:
	.dbline 77
	ldd 2,x
	cpd #10
	blt L35
	.dbline 79
	ldd #0
	std _on_track_yes
	.dbline 80
L35:
	.dbline 82
	jsr _IR_procT
	std 12,x
	.dbline 84
	ldd 12,x
	cpd #2
	bgt L39
	ldd 12,x
	cpd #-2
	bge L37
L39:
	.dbline 86
	ldd _current_lane
	cpd #1
	bne L40
	.dbline 88
	ldd #3
	jsr _turn
	.dbline 89
	ldd #350
	jsr _wait
	.dbline 90
	ldd #0
	std _on_track_yes
	.dbline 91
	bra L41
L40:
	.dbline 92
	ldd _current_lane
	cpd #2
	bne L42
	.dbline 94
	ldd #-3
	jsr _turn
	.dbline 95
	ldd #350
	jsr _wait
	.dbline 96
	ldd #0
	std _on_track_yes
	.dbline 97
L42:
L41:
	.dbline 99
L37:
	.dbline 102
L28:
	xgdx
	addd #14
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;      right_cds -> 2,x
;       left_cds -> 4,x
;           nose -> 6,x
;     turning_IR -> 8,x
_off_track::
	jsr __enterb
	.byte 0xa
	.dbfunc off_track
	.dbline 109
	jsr _IR_procT
	std 8,x
	.dbline 110
	ldd 8,x
	jsr _turn
	.dbline 111
	ldd #-2
	jsr _Accelerator
	std _velocity
	.dbline 112
	ldd #0
	std _current_lane
	.dbline 114
	ldd #0
	jsr _analog
	cpd #10
	ble L45
	ldd #0
	jsr _analog
	cpd #120
	bge L45
	.dbline 116
	ldd #4
	jsr _Accelerator
	.dbline 117
	jsr _turn_toward_ir
	.dbline 118
	ldd #800
	jsr _wait
	.dbline 119
L45:
	.dbline 121
	ldd #1
	jsr _analog
	std 6,x
	.dbline 122
	ldd #5
	jsr _analog
	std 4,x
	.dbline 123
	ldd #6
	jsr _analog
	std 2,x
	.dbline 125
	ldd 6,x
	cpd #190
	bgt X0
	jmp L47
X0:
	.dbline 130
	ldd #-1
	jsr _Accelerator
	.dbline 132
	ldd #0
	std _i
L49:
	.dbline 138
	ldd #5
	jsr _analog
	std _left_temp
	.dbline 139
	ldd #6
	jsr _analog
	std _right_temp
	.dbline 141
	ldd _left_temp
	cpd #195
	ble L53
	.dbline 144
	ldd #0
	std _j
	.dbline 145
	ldd #1
	jsr _analog
	std _nosej
	bra L56
L55:
	.dbline 148
	ldd #1
	jsr _analog
	std _nosej
	.dbline 149
L56:
	.dbline 146
	ldd _nosej
	cpd #195
	bgt L55
	bra L59
L58:
	.dbline 156
	ldd #1
	jsr _analog
	std _nosej
	.dbline 157
	ldd #3
	jsr _turn
	.dbline 158
	ldd _j
	addd #1
	std _j
	.dbline 159
L59:
	.dbline 150
	ldd _nosej
	cpd #195
	bgt L61
	ldd _j
	cpd #2500
	ble L58
L61:
	.dbline 162
; 				nosej = analog(1);
; 				turn(3);
; 				j++;
; 			}
; 			
; 			
; 			if (nosej > 195)
	ldd _nosej
	cpd #195
	bgt X1
	jmp L54
X1:
	.dbline 164
; 					{
; 						on_track_yes = 1;
	ldd #1
	std _on_track_yes
	.dbline 165
; 						current_lane = current_lane + 1;
	ldd _current_lane
	addd #1
	std _current_lane
	.dbline 166
; 						break;
	jmp L51
L53:
	.dbline 170
; 					}
; 					
; 		}
; 		else if (right_temp > 180)
	ldd _right_temp
	cpd #180
	ble L64
	.dbline 173
; 		{
; 			//printf("see right");
; 			k = 0;
	ldd #0
	std _k
	.dbline 174
; 			nosej = analog(1);
	ldd #1
	jsr _analog
	std _nosej
	bra L67
L66:
	.dbline 177
	ldd #1
	jsr _analog
	std _nosej
	.dbline 178
L67:
	.dbline 175
; 			while (nosej > 195)
	ldd _nosej
	cpd #195
	bgt L66
	bra L70
L69:
	.dbline 181
	ldd #1
	jsr _analog
	std _nosej
	.dbline 185
	ldd #-3
	jsr _turn
	.dbline 186
	ldd _k
	addd #1
	std _k
	.dbline 187
L70:
	.dbline 179
; 			{
; 			nosej = analog(1);
; 			}
; 			while ((nosej <= 195) && (k <= 2500))
	ldd _nosej
	cpd #195
	bgt L72
	ldd _k
	cpd #2500
	ble L69
L72:
	.dbline 189
; 			{
; 				nosej = analog(1);
; 				//printf("\t\nNoseJ= %d", nosej);
; 				//printf("\t\nK= %d", k);
; 				
; 				turn(-3);
; 				k++;
; 			}
; 			
; 			if (nosej > 195)
	ldd _nosej
	cpd #195
	ble L73
	.dbline 191
; 			{
; 				on_track_yes = 1;
	ldd #1
	std _on_track_yes
	.dbline 192
; 				current_lane = current_lane + 1;
	ldd _current_lane
	addd #1
	std _current_lane
	.dbline 193
; 				break;
	bra L51
L73:
	.dbline 195
; 			}
; 		}
L64:
L54:
	.dbline 196
; 	}
L50:
	ldd _i
	addd #1
	std _i
	cpd #3000
	bge X2
	jmp L49
X2:
L51:
	.dbline 197
; 	}
L47:
	.dbline 198
; }
L44:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         C_nose -> 2,x
;        C_right -> 4,x
;         C_left -> 6,x
;            XYZ -> 8,x
_CDS_procT::
	jsr __enterb
	.byte 0xa
	.dbfunc CDS_procT
	.dbline 205
; 	
; int CDS_procT()
; {
; 
; 	int C_left, C_right, C_nose, XYZ;
; 		
; 	C_left 	= analog(5);
	ldd #5
	jsr _analog
	std 6,x
	.dbline 206
; 	C_right  = analog(6);
	ldd #6
	jsr _analog
	std 4,x
	.dbline 207
; 	C_nose	= analog(1);
	ldd #1
	jsr _analog
	std 2,x
	.dbline 209
; 	
; 	XYZ = 0;
	ldd #0
	std 8,x
	.dbline 212
; 	
; 	//if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
; 	if ((C_left < L_L_min) && (C_right < L_R_min) && (C_nose < L_nose_min))
	ldd 6,x
	cpd _L_L_min
	bge L76
	ldd 4,x
	cpd _L_R_min
	bge L76
	ldd 2,x
	cpd _L_nose_min
	bge L76
	.dbline 214
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 215
; 	}
	bra L77
L76:
	.dbline 216
; 	else if (C_left > L_L_min)
	ldd 6,x
	cpd _L_L_min
	ble L78
	.dbline 218
; 	{
; 		XYZ = -3;
	ldd #-3
	std 8,x
	.dbline 219
; 	}
	bra L79
L78:
	.dbline 220
; 	else if (C_right > L_R_min)
	ldd 4,x
	cpd _L_R_min
	ble L80
	.dbline 222
; 	{
; 		XYZ = 3;
	ldd #3
	std 8,x
	.dbline 223
; 	}
	bra L81
L80:
	.dbline 224
; 	else if (C_nose > L_nose_min)
	ldd 2,x
	cpd _L_nose_min
	ble L82
	.dbline 226
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 227
; 	}
	bra L83
L82:
	.dbline 229
; 	//else if ((C_left < 225) && (C_right < 215))
; 	else if ((C_left < L_L_min) && (C_right < L_R_min))
	ldd 6,x
	cpd _L_L_min
	bge L84
	ldd 4,x
	cpd _L_R_min
	bge L84
	.dbline 231
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 232
; 	}
L84:
L83:
L81:
L79:
L77:
	.dbline 234
; 	
; 	return XYZ;
	ldd 8,x
L75:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 241
; }
; 
; void turn(int dot)
; {
; 	int degree;
; 	
; 	if (dot < 0)
	ldd 6,x
	bge L87
	.dbline 243
; 	{
; 		if (dot <= -3)
	ldd 6,x
	cpd #-3
	bgt L89
	.dbline 245
; 		{
; 			degree = 1500;
	ldd #1500
	std 2,x
	.dbline 246
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 248
; 			
; 		}
	jmp L88
L89:
	.dbline 249
; 		else if (dot <= -2)
	ldd 6,x
	cpd #-2
	bgt L91
	.dbline 251
; 		{
; 			degree = 1834;
	ldd #1834
	std 2,x
	.dbline 252
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 254
; 			
; 		}
	bra L88
L91:
	.dbline 255
; 		else if (dot <= -1)
	ldd 6,x
	cpd #-1
	bgt L88
	.dbline 257
; 		{
; 			degree = 2167;
	ldd #2167
	std 2,x
	.dbline 258
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 261
; 			
; 		}
; 	}
	bra L88
L87:
	.dbline 262
; 	else if (dot > 0)
	ldd 6,x
	ble L95
	.dbline 264
; 	{
; 		if (dot >= 3)
	ldd 6,x
	cpd #3
	blt L97
	.dbline 266
; 		{
; 			degree = 4000;
	ldd #4000
	std 2,x
	.dbline 267
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 269
; 			
; 		}
	bra L96
L97:
	.dbline 270
; 		else if (dot >= 2)
	ldd 6,x
	cpd #2
	blt L99
	.dbline 272
; 		{
; 			degree = 3500;
	ldd #3500
	std 2,x
	.dbline 273
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 275
; 			
; 		}
	bra L96
L99:
	.dbline 276
; 		else if (dot >= 1)
	ldd 6,x
	cpd #1
	blt L96
	.dbline 278
; 		{
; 			degree = 3000;
	ldd #3000
	std 2,x
	.dbline 279
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 282
; 			
; 		}
; 	}
	bra L96
L95:
	.dbline 285
; 	else
; 	{
; 		degree = 2500;
	ldd #2500
	std 2,x
	.dbline 286
; 		NoSignal;
	ldab #11
	stab 0x6000
	.dbline 287
; 	}
L96:
L88:
	.dbline 289
; 	
; 	servo(0, degree);
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 290
; 	wait(100);	
	ldd #100
	jsr _wait
	.dbline 292
; 
; }	
L86:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         t_diff -> 2,x
;          irT_R -> 4,x
;          irT_L -> 6,x
;             tR -> 8,x
;             tL -> 10,x
_IR_procT::
	jsr __enterb
	.byte 0xc
	.dbfunc IR_procT
	.dbline 298
; 
; int IR_procT()
; {
; 
; int irT_L, irT_R, t_diff;
; int tL = 0;
	ldd #0
	std 10,x
	.dbline 299
; int tR = 0;
	ldd #0
	std 8,x
	.dbline 300
; irT_L = analog(3);
	ldd #3
	jsr _analog
	std 6,x
	.dbline 301
; irT_R = analog(2);
	ldd #2
	jsr _analog
	std 4,x
	.dbline 307
; 
; //printf("\t%d\n", irT_L);
; //printf("\t\t%d\n", irT_R);
; 
; 
; if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L104
	.dbline 309
; {
; 	if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L105
	.dbline 311
; 	{
; 		tL = 1;
	ldd #1
	std 10,x
	.dbline 312
; 		if (irT_L > 105)
	ldd 6,x
	cpd #105
	ble L105
	.dbline 314
; 		{
; 			tL = tL + 1;	
	ldd 10,x
	addd #1
	std 10,x
	.dbline 315
; 			if (irT_L > 115)
	ldd 6,x
	cpd #115
	ble L105
	.dbline 317
; 			{
; 				tL = tL + 1;
	ldd 10,x
	addd #1
	std 10,x
	.dbline 321
; 			}
; 		}
; 	}
; }
	bra L105
L104:
	.dbline 324
; else
; 	{
; 		tL = 0;
	ldd #0
	std 10,x
	.dbline 325
; 	}	
L105:
	.dbline 328
; 
; 
; if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L112
	.dbline 331
; {
; 
; 	if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L113
	.dbline 333
; 	{
; 		tR = 1;
	ldd #1
	std 8,x
	.dbline 334
; 		if (irT_R > 105)
	ldd 4,x
	cpd #105
	ble L113
	.dbline 336
; 		{
; 			tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 337
; 			if (irT_R > 115)
	ldd 4,x
	cpd #115
	ble L113
	.dbline 339
; 			{
; 				tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 343
; 			}	
; 		}
; 	}
; }	
	bra L113
L112:
	.dbline 346
; else 
; 	{
; 		tR = 0;
	ldd #0
	std 8,x
	.dbline 347
; 	}	
L113:
	.dbline 349
; 
; t_diff = tL - tR;
	ldd 10,x
	subd 8,x
	std 2,x
	.dbline 358
; 
; //printf ("\ntL=%d\t", tL);
; //printf ("tR=%d\t", tR);
; //printf ("t_diff=%d", t_diff);
; 
; //if ( tL = tR )
; //	return tR;
; //else 
; 	return t_diff;
	ldd 2,x
L103:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;          speed -> 8,x
_Accelerator::
	jsr __enterb
	.byte 0x46
	.dbfunc Accelerator
	.dbline 370
; 	
; }
; 
; 
; int Accelerator(int speed)
; {
; 	
; 	int L_Speed, R_Speed;
; 	 
; 	
; 	
; 	if (speed <= 0)
	ldd 8,x
	ble X3
	jmp L121
X3:
	.dbline 372
; 	{
; 		if (speed <= -5)
	ldd 8,x
	cpd #-5
	bgt L123
	.dbline 374
; 		{
; 			L_Speed = -99;
	ldd #-99
	std 4,x
	.dbline 375
; 			R_Speed = 4;
	ldd #4
	std 2,x
	.dbline 376
; 		}
	jmp L122
L123:
	.dbline 377
; 		else if (speed <= -4)
	ldd 8,x
	cpd #-4
	bgt L125
	.dbline 379
; 		{
; 			L_Speed = -90;
	ldd #-90
	std 4,x
	.dbline 380
; 			R_Speed = 14;
	ldd #14
	std 2,x
	.dbline 381
; 		}
	jmp L122
L125:
	.dbline 382
; 		else if (speed <= -3)	
	ldd 8,x
	cpd #-3
	bgt L127
	.dbline 384
; 		{
; 			L_Speed = -80;
	ldd #-80
	std 4,x
	.dbline 385
; 			R_Speed = 24;
	ldd #24
	std 2,x
	.dbline 387
; 			//perfect
; 		}
	jmp L122
L127:
	.dbline 388
; 		else if (speed <= -2)
	ldd 8,x
	cpd #-2
	bgt L129
	.dbline 390
; 		{
; 			L_Speed = -70;
	ldd #-70
	std 4,x
	.dbline 391
; 			R_Speed = 34;
	ldd #34
	std 2,x
	.dbline 393
; 			//near perfect
; 		}
	jmp L122
L129:
	.dbline 394
; 		else if (speed <= -1)
	ldd 8,x
	cpd #-1
	bgt L131
	.dbline 396
; 		{
; 			L_Speed = -62;
	ldd #-62
	std 4,x
	.dbline 397
; 			R_Speed = 44;
	ldd #44
	std 2,x
	.dbline 398
; 		}
	jmp L122
L131:
	.dbline 399
; 		else if (speed <= 0)
	ldd 8,x
	ble X4
	jmp L122
X4:
	.dbline 401
; 		{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 402
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 404
; 		}
; 	}
	jmp L122
L121:
	.dbline 405
; 	else if (speed > 0)
	ldd 8,x
	bgt X5
	jmp L135
X5:
	.dbline 407
; 	{
; 		if (speed >= 5)
	ldd 8,x
	cpd #5
	blt L137
	.dbline 409
; 		{
; 			L_Speed = -6;
	ldd #-6
	std 4,x
	.dbline 410
; 			R_Speed = 99;
	ldd #99
	std 2,x
	.dbline 411
; 		}
	bra L136
L137:
	.dbline 412
; 		else if (speed >= 4)
	ldd 8,x
	cpd #4
	blt L139
	.dbline 414
; 		{
; 			L_Speed = -11;
	ldd #-11
	std 4,x
	.dbline 415
; 			R_Speed = 94;
	ldd #94
	std 2,x
	.dbline 416
; 		}
	bra L136
L139:
	.dbline 417
; 		else if (speed >= 3)
	ldd 8,x
	cpd #3
	blt L141
	.dbline 419
; 		{
; 			L_Speed = -19;
	ldd #-19
	std 4,x
	.dbline 420
; 			R_Speed = 84;
	ldd #84
	std 2,x
	.dbline 421
; 		}
	bra L136
L141:
	.dbline 422
; 		else if (speed >= 2)
	ldd 8,x
	cpd #2
	blt L143
	.dbline 424
; 		{
; 			L_Speed = -29;
	ldd #-29
	std 4,x
	.dbline 425
; 			R_Speed = 74;
	ldd #74
	std 2,x
	.dbline 426
; 		}
	bra L136
L143:
	.dbline 427
; 		else if (speed >= 1)
	ldd 8,x
	cpd #1
	blt L136
	.dbline 429
; 		{
; 			L_Speed = -41;
	ldd #-41
	std 4,x
	.dbline 430
; 			R_Speed = 64;
	ldd #64
	std 2,x
	.dbline 433
; 		}
; 		
; 	}
	bra L136
L135:
	.dbline 436
; 	else
; 	{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 437
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 438
; 	}		
L136:
L122:
	.dbline 442
; 
; 	
; 	
; 	if (speed < current_speed)
	ldd 8,x
	cpd _current_speed
	bge L147
	.dbline 444
; 	{
; 		BrakeLight;
	ldab #15
	stab 0x6000
	.dbline 445
; 	}
	bra L148
L147:
	.dbline 447
; 	else 
; 		NoSignal;
	ldab #11
	stab 0x6000
L148:
	.dbline 449
; 		
; 	motorp(0, L_Speed);
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 450
;    motorp(1, R_Speed);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 452
; 
; 	return current_speed;
	ldd _current_speed
L120:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         temp_R -> 2,x
;         temp_L -> 4,x
_turn_toward_ir::
	jsr __enterb
	.byte 0x6
	.dbfunc turn_toward_ir
	.dbline 462
; }
; 
; 
; void turn_toward_ir()
; {
; 
; 	int temp_L;
; 	int temp_R;
; 	
; 	temp_L = analog(3);
	ldd #3
	jsr _analog
	std 4,x
	.dbline 463
; 	temp_R = analog(2);
	ldd #2
	jsr _analog
	std 2,x
	.dbline 465
; 
; 	if (temp_L > temp_R)
	ldd 4,x
	cpd 2,x
	ble L150
	.dbline 467
; 		{
; 			turn(-3);
	ldd #-3
	jsr _turn
	.dbline 469
; 			//printf("-3");
; 		}
	bra L151
L150:
	.dbline 470
; 	else if (temp_R > temp_L)
	ldd 2,x
	cpd 4,x
	ble L152
	.dbline 472
; 		{
; 			turn(3);
	ldd #3
	jsr _turn
	.dbline 474
; 			//printf("3");
; 		}
L152:
L151:
	.dbline 476
; 	
; }
L149:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
	.area bss
_nosej::
	.blkb 2
_right_temp::
	.blkb 2
_left_temp::
	.blkb 2
_k::
	.blkb 2
_j::
	.blkb 2
_i::
	.blkb 2
_velocity::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
