#include <transam.h>
#include <stdio.h>


void track_follow();
int CDS_procT();

int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
int far_left = 1500;
int far_right = 4000;
//int current_speed = 0;
int spd_factorL, spd_factorR;
int irL, irR, turning_IR, d_of_turn, xx, yy, i, velocity;


H_L_min = 220;
H_R_min = 180;
H_nose_min = 170;

L_L_min = 200;
L_R_min = 175;
L_nose_min = 165;

void main(void)
{
	init_analog();
	init_motortjp();
	init_clocktjp();
	init_servotjp();
	
	NoSignal;
	
	START;
	
	IRE_ON;
	
	while(1)
	{
	track_follow();
	}
}

void track_follow()
{
	int temptrack;
	
	temptrack = CDS_procT();
	turn(temptrack);
	velocity = Accelerator(-3);
}


int CDS_procT()
{
	int C_left, C_right, C_nose, XYZ;
	
	
	
	C_left 	= analog(5);
	C_right = analog(6);
	C_nose	= analog(1);
	
	XYZ = 0;
	
	//if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
	if ((C_left < L_L_min) && (C_right < L_R_min) && (C_nose < L_nose_min))
	{
		XYZ = 0;
	}
	else if (C_left > L_L_min)
	{
		XYZ = -3;
	}
	else if (C_right > L_R_min)
	{
		XYZ = 3;
	}
	else if (C_nose > L_nose_min)
	{
		XYZ = 0;
	}
	//else if ((C_left < 225) && (C_right < 215))
	else if ((C_left < L_L_min) && (C_right < L_R_min))
	{
		XYZ = 0;
	}
	
	return XYZ;
}
	




