	.module avoid_t2.c
	.dbfile avoid_t2.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; 
; #include <transam.h>
; #include <stdio.h>
; 
; void avoidance();
; int IR_procT();
; int Accelerator(int);
; void turn(int);
; void turn_toward_ir();
; 
; int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
; int far_left = 1500;
; int far_right = 4000;
; int current_speed = 0;
; int spd_factorL, spd_factorR;
; int irL, irR, turning_IR, d_of_turn, xx, yy, i, velocity;
; 
; 
; void main(void)
; {
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	NoSignal;
; 	
; 	START;
; 	
; 	IRE_ON;
; 	
; 	while(1)
; 	{
; 	avoidance();
; 	}	
; 	
; }
; 
; void avoidance()
; {
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 	
; 	turning_IR = IR_procT();
; //	printf("\n%d\n", turning_IR);
; 	turn(turning_IR);
; 	velocity = Accelerator(-4);
; 	 if(FRONT_BUMP)
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
;     {
;       Accelerator(4); 	//reverse
;       turn_toward_ir();	//turn towards largest IR signal
;       wait(800);
;     }
; }
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 
; 
; void turn(int dot)
; {
; 	int degree;
; 	
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 	if (dot < 0)
; 	{
; 		if (dot <= -3)
; 		{
; 			degree = 1500;
; 			LeftSignal;
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 			
; 		}
; 		else if (dot <= -2)
; 		{
; 			degree = 1834;
; 			LeftSignal;
; 			
; 		}
; 		else if (dot <= -1)
; 		{
; 			degree = 2167;
; 			LeftSignal;
; 			
; 		}
; 	}
; 	else if (dot > 0)
; 	{
; 		if (dot >= 3)
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 		{
; 			degree = 4000;
; 			RightSignal;
; 			
; 		}
; 		else if (dot >= 2)
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 		{
; 			degree = 3500;
; 			RightSignal;
; 			
; 		}
; 		else if (dot >= 1)
; 		{
; 			degree = 3000;
; 			RightSignal;
; 			
; 		}
; 	}
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; 	else
; 	{
; 		degree = 2500;
; 		NoSignal;
; 	}
; 	
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	servo(0, degree);
; 	wait(100);	
; 
; }	
; 
; int IR_procT()
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; {
; 
; int irT_L, irT_R, t_diff;
; int tL = 0;
; int tR = 0;
; irT_L = analog(3);
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; irT_R = analog(2);
; 
; printf("\t%d\n", irT_L);
; printf("\t\t%d\n", irT_R);
; 
; 
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; if (irT_L > 95)
; {
; 	if (irT_L > 95)
; 	{
; 		tL = 1;
; 		if (irT_L > 105)
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 		{
; 			tL = tL + 1;	
; 			if (irT_L > 115)
; 			{
; 				tL = tL + 1;
; 			}
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 		}
; 	}
; }
; else
; 	{
; 		tL = 0;
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 	}	
; 
; 
; if (irT_R > 95)
; {
; 
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 	if (irT_R > 95)
; 	{
; 		tR = 1;
; 		if (irT_R > 105)
; 		{
; 			tR = tR + 1;
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_steering_center::
	.blkb 2
	.area idata
	.word 2500
	.area data
_far_left::
	.blkb 2
	.area idata
	.word 1500
	.area data
_far_right::
	.blkb 2
	.area idata
	.word 4000
	.area data
_current_speed::
	.blkb 2
	.area idata
	.word 0
	.area text
;  IX -> 0,x
_main::
	.dbfile avoid_t2.c
	.dbfunc main
	.dbline 22
	jsr _init_analog
	.dbline 23
	jsr _init_motortjp
	.dbline 24
	jsr _init_clocktjp
	.dbline 25
	jsr _init_servotjp
	.dbline 27
	ldab #11
	stab 0x6000
L20:
	.dbline 29
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 31
	ldab #7
	stab 0x7000
	bra L24
L23:
	.dbline 35
	jsr _avoidance
	.dbline 36
L24:
	.dbline 33
	bra L23
L19:
	rts
;  IX -> 0,x
_avoidance::
	.dbfunc avoidance
	.dbline 43
	jsr _IR_procT
	std _turning_IR
	.dbline 45
	ldd _turning_IR
	jsr _turn
	.dbline 46
	ldd #-4
	jsr _Accelerator
	std _velocity
	.dbline 47
	ldd #0
	jsr _analog
	cpd #10
	ble L27
	ldd #0
	jsr _analog
	cpd #120
	bge L27
	.dbline 49
	ldd #4
	jsr _Accelerator
	.dbline 50
	jsr _turn_toward_ir
	.dbline 51
	ldd #800
	jsr _wait
	.dbline 52
L27:
	.dbline 53
L26:
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 60
	ldd 6,x
	bge L30
	.dbline 62
	ldd 6,x
	cpd #-3
	bgt L32
	.dbline 64
	ldd #1500
	std 2,x
	.dbline 65
	ldab #1
	stab 0x6000
	.dbline 67
	jmp L31
L32:
	.dbline 68
	ldd 6,x
	cpd #-2
	bgt L34
	.dbline 70
	ldd #1834
	std 2,x
	.dbline 71
	ldab #1
	stab 0x6000
	.dbline 73
	bra L31
L34:
	.dbline 74
	ldd 6,x
	cpd #-1
	bgt L31
	.dbline 76
	ldd #2167
	std 2,x
	.dbline 77
	ldab #1
	stab 0x6000
	.dbline 80
	bra L31
L30:
	.dbline 81
	ldd 6,x
	ble L38
	.dbline 83
	ldd 6,x
	cpd #3
	blt L40
	.dbline 85
	ldd #4000
	std 2,x
	.dbline 86
	ldab #2
	stab 0x6000
	.dbline 88
	bra L39
L40:
	.dbline 89
	ldd 6,x
	cpd #2
	blt L42
	.dbline 91
	ldd #3500
	std 2,x
	.dbline 92
	ldab #2
	stab 0x6000
	.dbline 94
	bra L39
L42:
	.dbline 95
	ldd 6,x
	cpd #1
	blt L39
	.dbline 97
	ldd #3000
	std 2,x
	.dbline 98
	ldab #2
	stab 0x6000
	.dbline 101
	bra L39
L38:
	.dbline 104
	ldd #2500
	std 2,x
	.dbline 105
	ldab #11
	stab 0x6000
	.dbline 106
L39:
L31:
	.dbline 108
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 109
	ldd #100
	jsr _wait
	.dbline 111
L29:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         t_diff -> 2,x
;             tR -> 4,x
;             tL -> 6,x
;          irT_R -> 8,x
;          irT_L -> 10,x
_IR_procT::
	jsr __enterb
	.byte 0xc
	.dbfunc IR_procT
	.dbline 117
	ldd #0
	std 6,x
	.dbline 118
	ldd #0
	std 4,x
	.dbline 119
	ldd #3
	jsr _analog
	std 10,x
	.dbline 120
	ldd #2
	jsr _analog
	std 8,x
	.dbline 122
	ldd 10,x
	pshb
	psha
	ldd #L47
	jsr _printf
	puly
	.dbline 123
	ldd 8,x
	pshb
	psha
	ldd #L48
	jsr _printf
	puly
	.dbline 126
	ldd 10,x
	cpd #95
	ble L49
	.dbline 128
	ldd 10,x
	cpd #95
	ble L50
	.dbline 130
	ldd #1
	std 6,x
	.dbline 131
	ldd 10,x
	cpd #105
	ble L50
	.dbline 133
	ldd 6,x
	addd #1
	std 6,x
	.dbline 134
	ldd 10,x
	cpd #115
	ble L50
	.dbline 136
	ldd 6,x
	addd #1
	std 6,x
	.dbline 140
	bra L50
L49:
	.dbline 143
	ldd #0
	std 6,x
	.dbline 144
L50:
	.dbline 147
	ldd 8,x
	cpd #95
	ble L57
	.dbline 150
	ldd 8,x
	cpd #95
	ble L58
	.dbline 152
	ldd #1
	std 4,x
	.dbline 153
	ldd 8,x
	cpd #105
	ble L58
	.dbline 155
	ldd 4,x
	addd #1
	std 4,x
	.dbline 156
; 			if (irT_R > 115)
	ldd 8,x
	cpd #115
	ble L58
	.dbline 158
; 			{
; 				tR = tR + 1;
	ldd 4,x
	addd #1
	std 4,x
	.dbline 162
; 			}	
; 		}
; 	}
; }	
	bra L58
L57:
	.dbline 165
; else 
; 	{
; 		tR = 0;
	ldd #0
	std 4,x
	.dbline 166
; 	}	
L58:
	.dbline 168
; 
; t_diff = tL - tR;
	ldd 6,x
	subd 4,x
	std 2,x
	.dbline 177
; 
; //printf ("\ntL=%d\t", tL);
; //printf ("tR=%d\t", tR);
; //printf ("t_diff=%d", t_diff);
; 
; //if ( tL = tR )
; //	return tR;
; //else 
; 	return t_diff;
	ldd 2,x
L46:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;          speed -> 8,x
_Accelerator::
	jsr __enterb
	.byte 0x46
	.dbfunc Accelerator
	.dbline 188
; 	
; }
; 
; 
; int Accelerator(int speed)
; {
; 	int L_Speed, R_Speed;
; 	 
; 	
; 	
; 	if (speed <= 0)
	ldd 8,x
	ble X0
	jmp L66
X0:
	.dbline 190
; 	{
; 		if (speed <= -5)
	ldd 8,x
	cpd #-5
	bgt L68
	.dbline 192
; 		{
; 			L_Speed = -99;
	ldd #-99
	std 4,x
	.dbline 193
; 			R_Speed = 4;
	ldd #4
	std 2,x
	.dbline 194
; 		}
	jmp L67
L68:
	.dbline 195
; 		else if (speed <= -4)
	ldd 8,x
	cpd #-4
	bgt L70
	.dbline 197
; 		{
; 			L_Speed = -90;
	ldd #-90
	std 4,x
	.dbline 198
; 			R_Speed = 14;
	ldd #14
	std 2,x
	.dbline 199
; 		}
	jmp L67
L70:
	.dbline 200
; 		else if (speed <= -3)	
	ldd 8,x
	cpd #-3
	bgt L72
	.dbline 202
; 		{
; 			L_Speed = -80;
	ldd #-80
	std 4,x
	.dbline 203
; 			R_Speed = 24;
	ldd #24
	std 2,x
	.dbline 205
; 			//perfect
; 		}
	jmp L67
L72:
	.dbline 206
; 		else if (speed <= -2)
	ldd 8,x
	cpd #-2
	bgt L74
	.dbline 208
; 		{
; 			L_Speed = -70;
	ldd #-70
	std 4,x
	.dbline 209
; 			R_Speed = 34;
	ldd #34
	std 2,x
	.dbline 211
; 			//near perfect
; 		}
	jmp L67
L74:
	.dbline 212
; 		else if (speed <= -1)
	ldd 8,x
	cpd #-1
	bgt L76
	.dbline 214
; 		{
; 			L_Speed = -62;
	ldd #-62
	std 4,x
	.dbline 215
; 			R_Speed = 44;
	ldd #44
	std 2,x
	.dbline 216
; 		}
	jmp L67
L76:
	.dbline 217
; 		else if (speed <= 0)
	ldd 8,x
	ble X1
	jmp L67
X1:
	.dbline 219
; 		{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 220
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 222
; 		}
; 	}
	jmp L67
L66:
	.dbline 223
; 	else if (speed > 0)
	ldd 8,x
	bgt X2
	jmp L80
X2:
	.dbline 225
; 	{
; 		if (speed >= 5)
	ldd 8,x
	cpd #5
	blt L82
	.dbline 227
; 		{
; 			L_Speed = -6;
	ldd #-6
	std 4,x
	.dbline 228
; 			R_Speed = 99;
	ldd #99
	std 2,x
	.dbline 229
; 		}
	bra L81
L82:
	.dbline 230
; 		else if (speed >= 4)
	ldd 8,x
	cpd #4
	blt L84
	.dbline 232
; 		{
; 			L_Speed = -11;
	ldd #-11
	std 4,x
	.dbline 233
; 			R_Speed = 94;
	ldd #94
	std 2,x
	.dbline 234
; 		}
	bra L81
L84:
	.dbline 235
; 		else if (speed >= 3)
	ldd 8,x
	cpd #3
	blt L86
	.dbline 237
; 		{
; 			L_Speed = -19;
	ldd #-19
	std 4,x
	.dbline 238
; 			R_Speed = 84;
	ldd #84
	std 2,x
	.dbline 239
; 		}
	bra L81
L86:
	.dbline 240
; 		else if (speed >= 2)
	ldd 8,x
	cpd #2
	blt L88
	.dbline 242
; 		{
; 			L_Speed = -29;
	ldd #-29
	std 4,x
	.dbline 243
; 			R_Speed = 74;
	ldd #74
	std 2,x
	.dbline 244
; 		}
	bra L81
L88:
	.dbline 245
; 		else if (speed >= 1)
	ldd 8,x
	cpd #1
	blt L81
	.dbline 247
; 		{
; 			L_Speed = -41;
	ldd #-41
	std 4,x
	.dbline 248
; 			R_Speed = 64;
	ldd #64
	std 2,x
	.dbline 251
; 		}
; 		
; 	}
	bra L81
L80:
	.dbline 254
; 	else
; 	{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 255
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 256
; 	}		
L81:
L67:
	.dbline 260
; 
; 	
; 	
; 	if (speed < current_speed)
	ldd 8,x
	cpd _current_speed
	bge L92
	.dbline 262
; 	{
; 		BrakeLight;
	ldab #15
	stab 0x6000
	.dbline 263
; 	}
	bra L93
L92:
	.dbline 265
; 	else 
; 		NoSignal;
	ldab #11
	stab 0x6000
L93:
	.dbline 267
; 		
; 	motorp(0, L_Speed);
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 268
; 	motorp(1, R_Speed);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 270
; 
; 	return current_speed;
	ldd _current_speed
L65:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         temp_R -> 2,x
;         temp_L -> 4,x
_turn_toward_ir::
	jsr __enterb
	.byte 0x6
	.dbfunc turn_toward_ir
	.dbline 279
; }
; 
; void turn_toward_ir()
; {
; 
; 	int temp_L;
; 	int temp_R;
; 	
; 	temp_L = analog(3);
	ldd #3
	jsr _analog
	std 4,x
	.dbline 280
; 	temp_R = analog(2);
	ldd #2
	jsr _analog
	std 2,x
	.dbline 282
; 
; 	if (temp_L > temp_R)
	ldd 4,x
	cpd 2,x
	ble L95
	.dbline 284
; 		{
; 			turn(-3);
	ldd #-3
	jsr _turn
	.dbline 285
; 			printf("-3");
	ldd #L97
	jsr _printf
	.dbline 286
; 		}
	bra L96
L95:
	.dbline 287
; 	else if (temp_R > temp_L)
	ldd 2,x
	cpd 4,x
	ble L98
	.dbline 289
; 		{
; 			turn(3);
	ldd #3
	jsr _turn
	.dbline 290
; 			printf("3");
	ldd #L100
	jsr _printf
	.dbline 291
; 		}
L98:
L96:
	.dbline 292
; }
L94:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
	.area bss
_velocity::
	.blkb 2
_i::
	.blkb 2
_yy::
	.blkb 2
_xx::
	.blkb 2
_d_of_turn::
	.blkb 2
_turning_IR::
	.blkb 2
_irR::
	.blkb 2
_irL::
	.blkb 2
_spd_factorR::
	.blkb 2
_spd_factorL::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L100:
	.byte 51,0
L97:
	.byte 45,51,0
L48:
	.byte 9,9,37,'d,10,0
L47:
	.byte 9,37,'d,10,0
