	.module posttest.c
	.dbfile posttest.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /* 	
;  * Title        transam2.c     
;  * Programmer	Jason Grzywna
;  * Date         March 23, 2000
;  * Version		2.0c			               										        
;  * Description									
;  *    A very simple collision avoidance program. TJ PRO will read 	
;  *    each IR detectors, and turn away from any obstacles in its	
;  *    path. Also, if something hits TJ PRO's bumper, it will back up,	
;  *    turn, and go on.							
;  *			                                               
;  */
; 
; #include <tjpbase.h>
; #include <stdio.h>
; 
; 
; #define START 	while(BUMPER<120)
; #define LIGHTS_PORT	*(unsigned char *)(0x6000)
; #define DebugSW	analog(7)
; #define CDSnose	analog(1)
; #define CDS_L		analog(5)
; #define CDS_R		analog(6)
; 
; int poweronselftest(void);
; void avoidance(void);
; int IR_processor();
; int Velocity_processor();
; void WhiteRabbit();
; void turn(int);
; void light(int);
; 
; 
; 
; 	int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
; 	int far_left = 1600;
; 	int far_right = 3300;
; 	int speed = 0;
; 	int irL, irR, IRprocessed, d_of_turn, xx, i;
; 
; 
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; void main(void)
; {
; 
; 	int temp1 = 99;
; 		
; 	init_analog();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	CLEAR_BIT(LIGHTS_PORT, 0xFF);  /* TURN OFF LIGHTS INITIALLY */
; 	
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
;  	if (DebugSW > 100)
;  	{
;  		temp1 = poweronselftest();
;  		printf("\nerrors = %d\n", temp1);
;  		/*WhiteRabbit();*/
;  	}
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
;  	
;  	
;  	START;
;  	IRE_ON;
;  	while(1)
;  	{
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
;  	IRprocessed = IR_processor();
;  	printf("\n%d\n", IRprocessed);
;  	wait(400);
;  	Velocity_processor();
;  	avoidance();
;   	}
;   
;        
; }
; 
; 
; int poweronselftest(void)
; {
; 	int errors = 0;
; 	int lir, rir;
; 	
; 	/* STEERING TEST */
; 
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	servo(0, steering_center);
; 	printf("\ncenter\n");
; 	wait(300);
; 	servo(0, far_left);
; 	printf("\nleft\n");
; 	wait(300);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 	servo(0, far_right);
; 	printf("\nright\n");
; 	wait(300);
; 	servo(0, steering_center);
; 	wait(300);
; 	
; 	/* IR TEST */
; 	 
; 	IRE_ON;
; 	lir = LEFT_IR;
; 	rir = RIGHT_IR;
; 	
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; 	if ((lir>85)&&(lir<135))
; 	{}
; 	else 
; 		errors = errors + 1;
; 	
; 	if ((rir>85)&&(rir<135))
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	{}
; 	else
; 		errors = errors + 1;
; 	IRE_OFF;
; 		
; 	/* BUMP SWITCH TEST */
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 	
; 	if (analog(0) > 3)
; 		errors = errors + 1;
; 	
; 	/* MOTOR TEST */
; 	
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 	motorp(0, 100);
; 	motorp(1, 100);
; 	wait(100);
; 	motorp(0, -100);
; 	motorp(1, -100);
; 	wait(100);
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 	motorp(0, 0);
; 	motorp(1, 0);
; 	
; return errors;	
; }
; 
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 
; 
; 
; void avoidance(void)
; {
; 	motorp(0, 100);
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 	motorp(1, 100);
; 	turn(3);
; 	
; 	/*
; 		
; 	printf("turn(");
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 	xx = read_int();
; 	turn(xx);*/			 
; 		
; /*	for(i=-3; i<4; i+=1) 			
;         {
;           printf("\n\n%d\n\n",i);
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
;           turn(i);  
;           wait(40);     
;         }
;      for(i=3; i>-4; i-=1) 
;         {
;           printf("\n\n%d\n\n",i);
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_steering_center::
	.blkb 2
	.area idata
	.word 2500
	.area data
_far_left::
	.blkb 2
	.area idata
	.word 1600
	.area data
_far_right::
	.blkb 2
	.area idata
	.word 3300
	.area data
_speed::
	.blkb 2
	.area idata
	.word 0
	.area text
;  IX -> 0,x
;          temp1 -> 2,x
_main::
	jsr __enterb
	.byte 0x4
	.dbfile posttest.c
	.dbfunc main
	.dbline 45
	ldd #99
	std 2,x
	.dbline 47
	jsr _init_analog
	.dbline 48
	jsr _init_motortjp
	.dbline 49
	jsr _init_clocktjp
	.dbline 50
	jsr _init_servotjp
	.dbline 52
	ldy #0x6000
	bclr 0,y,#0xff
	.dbline 54
	ldd #7
	jsr _analog
	cpd #100
	ble L24
	.dbline 56
	jsr _poweronselftest
	std 2,x
	.dbline 57
	ldd 2,x
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 59
L23:
	.dbline 62
L24:
	ldd #0
	jsr _analog
	cpd #120
	blt L23
	.dbline 63
	ldab #7
	stab 0x7000
	bra L27
L26:
	.dbline 66
	jsr _IR_processor
	std _IRprocessed
	.dbline 67
	ldd _IRprocessed
	pshb
	psha
	ldd #L29
	jsr _printf
	puly
	.dbline 68
	ldd #400
	jsr _wait
	.dbline 69
	jsr _Velocity_processor
	.dbline 70
	jsr _avoidance
	.dbline 71
L27:
	.dbline 64
	bra L26
L19:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;            rir -> 2,x
;            lir -> 4,x
;         errors -> 6,x
_poweronselftest::
	jsr __enterb
	.byte 0x8
	.dbfunc poweronselftest
	.dbline 79
	ldd #0
	std 6,x
	.dbline 84
	ldd _steering_center
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 85
	ldd #L31
	jsr _printf
	.dbline 86
	ldd #300
	jsr _wait
	.dbline 87
	ldd _far_left
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 88
	ldd #L32
	jsr _printf
	.dbline 89
	ldd #300
	jsr _wait
	.dbline 90
	ldd _far_right
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 91
	ldd #L33
	jsr _printf
	.dbline 92
	ldd #300
	jsr _wait
	.dbline 93
	ldd _steering_center
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 94
	ldd #300
	jsr _wait
	.dbline 98
	ldab #7
	stab 0x7000
	.dbline 99
	ldd #3
	jsr _analog
	std 4,x
	.dbline 100
	ldd #2
	jsr _analog
	std 2,x
	.dbline 102
	ldd 4,x
	cpd #85
	ble L34
	ldd 4,x
	cpd #135
	bge L34
	.dbline 103
	bra L35
L34:
	.dbline 105
	ldd 6,x
	addd #1
	std 6,x
L35:
	.dbline 107
	ldd 2,x
	cpd #85
	ble L36
	ldd 2,x
	cpd #135
	bge L36
	.dbline 108
	bra L37
L36:
	.dbline 110
	ldd 6,x
	addd #1
	std 6,x
L37:
	.dbline 111
	clr 0x7000
	.dbline 115
	ldd #0
	jsr _analog
	cpd #3
	ble L38
	.dbline 116
	ldd 6,x
	addd #1
	std 6,x
L38:
	.dbline 120
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 121
	ldd #100
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 122
	ldd #100
	jsr _wait
	.dbline 123
	ldd #-100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 124
	ldd #-100
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 125
	ldd #100
	jsr _wait
	.dbline 126
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 127
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 129
	ldd 6,x
L30:
	xgdx
	addd #8
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_avoidance::
	.dbfunc avoidance
	.dbline 137
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 138
	ldd #100
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 139
	ldd #3
	jsr _turn
	.dbline 160
;           turn(i);
;           wait(40);
;         }       
; */
; }
L40:
	rts
;  IX -> 0,x
;         IRout1 -> 2,x
;        irRtemp -> 4,x
;        irLtemp -> 6,x
;          IRout -> 8,x
;         IRtemp -> 10,x
_IR_processor::
	jsr __enterb
	.byte 0xc
	.dbfunc IR_processor
	.dbline 168
; 
; 
; 	
; int IR_processor(void)
; {
; 	int IRout, IRout1, IRtemp, irLtemp, irRtemp;
; 		
; 	irL = analog(3);
	ldd #3
	jsr _analog
	std _irL
	.dbline 169
; 	irR = analog(2);
	ldd #2
	jsr _analog
	std _irR
	.dbline 172
; 	
; 	
; 	printf("\nIR Left - %d", irL);
	ldd _irL
	pshb
	psha
	ldd #L42
	jsr _printf
	puly
	.dbline 173
; 	printf("\nIR Right - %d", irR);
	ldd _irR
	pshb
	psha
	ldd #L43
	jsr _printf
	puly
	.dbline 174
; 		irLtemp = -irL;
	ldd _irL
	nega
	negb
	sbca #0
	std 6,x
	.dbline 175
; 		irRtemp = irR;
	ldd _irR
	std 4,x
	.dbline 176
; 		IRtemp = (irLtemp + irRtemp);
	ldd 6,x
	addd 4,x
	std 10,x
	.dbline 182
; 
; 	
; 	/*IRout1 = (IRtemp * 2.5);
; 	printf("\nIRout1 - %d", IRout1);*/ 				/* Scales to -100 -> 100 */
; 		
; 	if ((IRtemp < 12) && (IRtemp > -12)) /* || (IRtemp = 0))		/* Processes Depth is object is centered */		
	ldd 10,x
	cpd #12
	blt X0
	jmp L44
X0:
	ldd 10,x
	cpd #-12
	bgt X1
	jmp L44
X1:
	.dbline 184
; 	{ 
; 		if ((irL < 95) && (irR < 95))
	ldd _irL
	cpd #95
	bge L46
	ldd _irR
	cpd #95
	bge L46
	.dbline 186
; 		{
; 			IRout = 11;
	ldd #11
	std 8,x
	.dbline 187
; 		}
	jmp L45
L46:
	.dbline 188
; 		else if ((irL < 105) && (irR < 105))
	ldd _irL
	cpd #105
	bge L48
	ldd _irR
	cpd #105
	bge L48
	.dbline 190
; 		{
; 			IRout = 22;
	ldd #22
	std 8,x
	.dbline 191
; 		}
	bra L45
L48:
	.dbline 192
; 		else if ((irL < 115) && (irR < 115))
	ldd _irL
	cpd #115
	bge L50
	ldd _irR
	cpd #115
	bge L50
	.dbline 194
; 		{
; 			IRout = 33;
	ldd #33
	std 8,x
	.dbline 195
; 		}
	bra L45
L50:
	.dbline 196
; 		else if ((irL < 124) && (irR < 124))
	ldd _irL
	cpd #124
	bge L52
	ldd _irR
	cpd #124
	bge L52
	.dbline 198
; 		{
; 			IRout = 44;
	ldd #44
	std 8,x
	.dbline 199
; 		}
	bra L45
L52:
	.dbline 200
; 		else if ((irL > 125) && (irR > 125))
	ldd _irL
	cpd #125
	ble L45
	ldd _irR
	cpd #125
	ble L45
	.dbline 202
; 		{
; 			IRout = 55;
	ldd #55
	std 8,x
	.dbline 203
; 			printf("CLOSE");
	ldd #L56
	jsr _printf
	.dbline 205
; 		}
; 	}
	bra L45
L44:
	.dbline 208
; 	else
; 	{
; 		IRout = IRtemp; /*(IRout1 / 10);*/
	ldd 10,x
	std 8,x
	.dbline 209
; 		printf("\n\nIRout!!! - %d", IRout);
	ldd 8,x
	pshb
	psha
	ldd #L57
	jsr _printf
	puly
	.dbline 210
; 	}
L45:
	.dbline 213
; 		
; 	
; 	return IRout;
	ldd 8,x
L41:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;      new_speed -> 2,x
_Velocity_processor::
	jsr __enterb
	.byte 0x4
	.dbfunc Velocity_processor
	.dbline 224
; }
; 
; 
; 
; int Velocity_processor()
; {
; 	int new_speed;
; 	
; 		
; 
; 	return new_speed;
	ldd 2,x
L58:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 233
; }
; 
; 
; 
; void turn(int dot)
; {
; 	int degree;
; 	
; 	if (dot < 0)
	ldd 6,x
	bge L60
	.dbline 235
; 	{
; 		if (dot <= -3)
	ldd 6,x
	cpd #-3
	bgt L62
	.dbline 237
; 		{
; 			degree = 1750;
	ldd #1750
	std 2,x
	.dbline 238
; 			SET_BIT(LIGHTS_PORT, 0x01);
	ldy #0x6000
	bset 0,y,#1
	.dbline 239
; 		}
	jmp L61
L62:
	.dbline 240
; 		else if (dot <= -2)
	ldd 6,x
	cpd #-2
	bgt L64
	.dbline 242
; 		{
; 			degree = 2000;
	ldd #2000
	std 2,x
	.dbline 243
; 			SET_BIT(LIGHTS_PORT, 0x01);
	ldy #0x6000
	bset 0,y,#1
	.dbline 244
; 		}
	jmp L61
L64:
	.dbline 245
; 		else if (dot <= -1)
	ldd 6,x
	cpd #-1
	ble X2
	jmp L61
X2:
	.dbline 247
; 		{
; 			degree = 2300;
	ldd #2300
	std 2,x
	.dbline 248
; 			SET_BIT(LIGHTS_PORT, 0x01);
	ldy #0x6000
	bset 0,y,#1
	.dbline 250
; 		}
; 	}
	bra L61
L60:
	.dbline 251
; 	else if (dot > 0)
	ldd 6,x
	ble L68
	.dbline 253
; 	{
; 		if (dot >= 3)
	ldd 6,x
	cpd #3
	blt L70
	.dbline 255
; 		{
; 			degree = 3450;
	ldd #3450
	std 2,x
	.dbline 256
; 			SET_BIT(LIGHTS_PORT, 0x02);
	ldy #0x6000
	bset 0,y,#2
	.dbline 257
; 		}
	bra L69
L70:
	.dbline 258
; 		else if (dot >= 2)
	ldd 6,x
	cpd #2
	blt L72
	.dbline 260
; 		{
; 			degree = 2900;
	ldd #2900
	std 2,x
	.dbline 261
; 			SET_BIT(LIGHTS_PORT, 0x02);
	ldy #0x6000
	bset 0,y,#2
	.dbline 262
; 		}
	bra L69
L72:
	.dbline 263
; 		else if (dot >= 1)
	ldd 6,x
	cpd #1
	blt L69
	.dbline 265
; 		{
; 			degree = 2700;
	ldd #2700
	std 2,x
	.dbline 266
; 			SET_BIT(LIGHTS_PORT, 0x02);
	ldy #0x6000
	bset 0,y,#2
	.dbline 268
; 		}
; 	}
	bra L69
L68:
	.dbline 271
; 	else
; 	{
; 		degree = 2500;
	ldd #2500
	std 2,x
	.dbline 272
; 		CLEAR_BIT(LIGHTS_PORT, 0x03);
	ldy #0x6000
	bclr 0,y,#0x3
	.dbline 273
; 	}
L69:
L61:
	.dbline 275
; 	
; 	printf("%d", degree);
	ldd 2,x
	pshb
	psha
	ldd #L76
	jsr _printf
	puly
	.dbline 276
; 	servo(0, degree);	
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 278
; 
; }
L59:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;           bulb -> 2,x
_light::
	.dbfunc light
	.dbline 287
; 
; void light(int bulb)
; {
; 
; 
; 
; 
; 
; }
L77:
	rts
L79:
	.byte 27,91,50,'J,4,0
L80:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;             c1 -> 3,x
;             c2 -> 4,x
;          place -> 5,x
;          clear -> 12,x
_WhiteRabbit::
	jsr __enterb
	.byte 0x12
	.dbfunc WhiteRabbit
	.dbline 291
; 
; void WhiteRabbit()
; {
; char c1, clear[]= "\x1b\x5B\x32\x4A\x04";
	ldd 0,x
	addd #12
	ldy #L79
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 292
; char place[]= "\x1b[1;1H";	/*Home*/	
	ldd 0,x
	addd #5
	ldy #L80
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 295
; char c2;
; 
; printf("%s", clear);  
	ldd 0,x
	addd #12
	pshb
	psha
	ldd #L81
	jsr _printf
	puly
	.dbline 296
; printf("%s", place);
	ldd 0,x
	addd #5
	pshb
	psha
	ldd #L81
	jsr _printf
	puly
	.dbline 298
; 
; printf("\tTitle\t\White Rabbit\n"
	ldd #L82
	jsr _printf
	.dbline 303
;   "\tProgrammer\tJason Grzywna\n"
;   "\tDate\t\tMarch, 2000\n"
;   "\tVersion\t\t1.0\n\n");
;   
; printf("TRANS AM Manual Driver\n\n");
	ldd #L83
	jsr _printf
	.dbline 304
; printf("Enter Command: W=forward, X=reverse, D=increase R, A=increase L\n");
	ldd #L84
	jsr _printf
	.dbline 306
; 
; c2 = get_char();
	jsr _get_char
	stab 4,x
	.dbline 307
; }
L78:
	xgdx
	addd #18
	xgdx
	txs
	pulx
	rts
	.area bss
_i::
	.blkb 2
_xx::
	.blkb 2
_d_of_turn::
	.blkb 2
_IRprocessed::
	.blkb 2
_irR::
	.blkb 2
_irL::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L84:
	.byte 'E,'n,'t,'e,'r,32,'C,'o,'m,'m,'a,'n,'d,58,32,'W
	.byte 61,'f,'o,'r,'w,'a,'r,'d,44,32,'X,61,'r,'e,'v,'e
	.byte 'r,'s,'e,44,32,'D,61,'i,'n,'c,'r,'e,'a,'s,'e,32
	.byte 'R,44,32,'A,61,'i,'n,'c,'r,'e,'a,'s,'e,32,'L,10
	.byte 0
L83:
	.byte 'T,'R,'A,'N,'S,32,'A,'M,32,'M,'a,'n,'u,'a,'l,32
	.byte 'D,'r,'i,'v,'e,'r,10,10,0
L82:
	.byte 9,'T,'i,'t,'l,'e,9,'W,'h,'i,'t,'e,32,'R,'a,'b
	.byte 'b,'i,'t,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9
	.byte 'J,'a,'s,'o,'n,32,'G,'r,'z,'y,'w,'n,'a,10,9,'D
	.byte 'a,'t,'e,9,9,'M,'a,'r,'c,'h,44,32,50,48,48,48
	.byte 10,9,'V,'e,'r,'s,'i,'o,'n,9,9,49,46,48,10,10
	.byte 0
L81:
	.byte 37,'s,0
L76:
	.byte 37,'d,0
L57:
	.byte 10,10,'I,'R,'o,'u,'t,33,33,33,32,45,32,37,'d,0
L56:
	.byte 'C,'L,'O,'S,'E,0
L43:
	.byte 10,'I,'R,32,'R,'i,'g,'h,'t,32,45,32,37,'d,0
L42:
	.byte 10,'I,'R,32,'L,'e,'f,'t,32,45,32,37,'d,0
L33:
	.byte 10,'r,'i,'g,'h,'t,10,0
L32:
	.byte 10,'l,'e,'f,'t,10,0
L31:
	.byte 10,'c,'e,'n,'t,'e,'r,10,0
L29:
	.byte 10,37,'d,10,0
L22:
	.byte 10,'e,'r,'r,'o,'r,'s,32,61,32,37,'d,10,0
