	.module track_f.c
	.dbfile track_f.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; #include <transam.h>
; #include <stdio.h>
; 
; 
; void track_follow();
; int CDS_procT();
; int Accelerator(int);
; void turn(int);
; 
; int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
; int far_left = 1650;
; int far_right = 3800;
; int current_speed = 0;
; int spd_factorL, spd_factorR;
; int irL, irR, turning_IR, d_of_turn, xx, yy, i, velocity;
; 
; void main(void)
; {
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	NoSignal;
; 	
; 	START;
; 	
; 	IRE_ON;
; 	
; 	while(1)
; 	{
; 	track_follow();
; 	}
; }
; 
; void track_follow()
; {
; 	int temptrack;
; 	
; 	temptrack = CDS_procT();
; 	turn(temptrack);
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 	velocity = Accelerator(-3);
; 	
; 
; 
; }
; 
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 
; int CDS_procT()
; {
; 	int C_left, C_right, C_nose, XYZ;
; 	
; 	
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 	
; 	C_left 	= analog(5);
; 	C_right = analog(6);
; 	C_nose	= analog(1);
; 	
; 	XYZ = 0;
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 	
; 	if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
; 	{
; 		XYZ = 0;
; 	}
; 	else if (C_left > 220)
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 	{
; 		XYZ = -3;
; 	}
; 	else if (C_right > 180)
; 	{
; 		XYZ = 3;
; 	}
; 	else if (C_nose > 170)
; 	{
; 		XYZ = 0;
; 	}
; 	else if ((C_left < 225) && (C_right < 215))
; 	{
; 		XYZ = 0;
; 	}
; 	
; 	return XYZ;
; }
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	
; 
; void turn(int dot)
; {
; 	int degree;
; 	
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 	if (dot < 0)
; 	{
; 		if (dot <= -3)
; 		{
; 			degree = 1650;
; 			LeftSignal;
; 			
; 		}
; 		else if (dot <= -2)
; 		{
; 			degree = 2000;
; 			LeftSignal;
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; 			
; 		}
; 		else if (dot <= -1)
; 		{
; 			degree = 2300;
; 			LeftSignal;
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 			
; 		}
; 	}
; 	else if (dot > 0)
; 	{
; 		if (dot >= 3)
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 		{
; 			degree = 3800;
; 			RightSignal;
; 			
; 		}
; 		else if (dot >= 2)
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 		{
; 			degree = 2900;
; 			RightSignal;
; 			
; 		}
; 		else if (dot >= 1)
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 		{
; 			degree = 2700;
; 			RightSignal;
; 			
; 		}
; 	}
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	else
; 	{
; 		degree = 2500;
; 		NoSignal;
; 	}
; 	
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 	servo(0, degree);	
; 	wait(125);
; 
; }	
; 
; int Accelerator(int speed)
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; {
; 	int L_Speed, R_Speed;
; 	 
; 	
; 	
; 	if (speed <= 0)
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 	{
; 		if (speed <= -5)
; 		{
; 			L_Speed = -99;
; 			R_Speed = 4;
; 		}
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_steering_center::
	.blkb 2
	.area idata
	.word 2500
	.area data
_far_left::
	.blkb 2
	.area idata
	.word 1650
	.area data
_far_right::
	.blkb 2
	.area idata
	.word 3800
	.area data
_current_speed::
	.blkb 2
	.area idata
	.word 0
	.area text
;  IX -> 0,x
_main::
	.dbfile track_f.c
	.dbfunc main
	.dbline 19
	jsr _init_analog
	.dbline 20
	jsr _init_motortjp
	.dbline 21
	jsr _init_clocktjp
	.dbline 22
	jsr _init_servotjp
	.dbline 24
	ldab #11
	stab 0x6000
L20:
	.dbline 26
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 28
	ldab #7
	stab 0x7000
	bra L24
L23:
	.dbline 32
	jsr _track_follow
	.dbline 33
L24:
	.dbline 30
	bra L23
L19:
	rts
;  IX -> 0,x
;      temptrack -> 2,x
_track_follow::
	jsr __enterb
	.byte 0x4
	.dbfunc track_follow
	.dbline 40
	jsr _CDS_procT
	std 2,x
	.dbline 41
	ldd 2,x
	jsr _turn
	.dbline 42
	ldd #-3
	jsr _Accelerator
	std _velocity
	.dbline 46
L26:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;         C_nose -> 2,x
;        C_right -> 4,x
;         C_left -> 6,x
;            XYZ -> 8,x
_CDS_procT::
	jsr __enterb
	.byte 0xa
	.dbfunc CDS_procT
	.dbline 55
	ldd #5
	jsr _analog
	std 6,x
	.dbline 56
	ldd #6
	jsr _analog
	std 4,x
	.dbline 57
	ldd #1
	jsr _analog
	std 2,x
	.dbline 59
	ldd #0
	std 8,x
	.dbline 61
	ldd 6,x
	cpd #225
	bge L28
	ldd 4,x
	cpd #215
	bge L28
	ldd 2,x
	cpd #185
	bge L28
	.dbline 63
	ldd #0
	std 8,x
	.dbline 64
	bra L29
L28:
	.dbline 65
	ldd 6,x
	cpd #220
	ble L30
	.dbline 67
	ldd #-3
	std 8,x
	.dbline 68
	bra L31
L30:
	.dbline 69
	ldd 4,x
	cpd #180
	ble L32
	.dbline 71
	ldd #3
	std 8,x
	.dbline 72
	bra L33
L32:
	.dbline 73
	ldd 2,x
	cpd #170
	ble L34
	.dbline 75
	ldd #0
	std 8,x
	.dbline 76
	bra L35
L34:
	.dbline 77
	ldd 6,x
	cpd #225
	bge L36
	ldd 4,x
	cpd #215
	bge L36
	.dbline 79
	ldd #0
	std 8,x
	.dbline 80
L36:
L35:
L33:
L31:
L29:
	.dbline 82
	ldd 8,x
L27:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 90
	ldd 6,x
	bge L39
	.dbline 92
	ldd 6,x
	cpd #-3
	bgt L41
	.dbline 94
	ldd #1650
	std 2,x
	.dbline 95
	ldab #1
	stab 0x6000
	.dbline 97
	jmp L40
L41:
	.dbline 98
	ldd 6,x
	cpd #-2
	bgt L43
	.dbline 100
	ldd #2000
	std 2,x
	.dbline 101
	ldab #1
	stab 0x6000
	.dbline 103
	bra L40
L43:
	.dbline 104
	ldd 6,x
	cpd #-1
	bgt L40
	.dbline 106
	ldd #2300
	std 2,x
	.dbline 107
	ldab #1
	stab 0x6000
	.dbline 110
	bra L40
L39:
	.dbline 111
	ldd 6,x
	ble L47
	.dbline 113
	ldd 6,x
	cpd #3
	blt L49
	.dbline 115
	ldd #3800
	std 2,x
	.dbline 116
	ldab #2
	stab 0x6000
	.dbline 118
	bra L48
L49:
	.dbline 119
	ldd 6,x
	cpd #2
	blt L51
	.dbline 121
	ldd #2900
	std 2,x
	.dbline 122
	ldab #2
	stab 0x6000
	.dbline 124
	bra L48
L51:
	.dbline 125
	ldd 6,x
	cpd #1
	blt L48
	.dbline 127
	ldd #2700
	std 2,x
	.dbline 128
	ldab #2
	stab 0x6000
	.dbline 131
	bra L48
L47:
	.dbline 134
	ldd #2500
	std 2,x
	.dbline 135
	ldab #11
	stab 0x6000
	.dbline 136
L48:
L40:
	.dbline 138
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 139
	ldd #125
	jsr _wait
	.dbline 141
L38:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;          speed -> 8,x
_Accelerator::
	jsr __enterb
	.byte 0x46
	.dbfunc Accelerator
	.dbline 149
	ldd 8,x
	ble X0
	jmp L56
X0:
	.dbline 151
	ldd 8,x
	cpd #-5
	bgt L58
	.dbline 153
	ldd #-99
	std 4,x
	.dbline 154
	ldd #4
	std 2,x
	.dbline 155
	jmp L57
L58:
	.dbline 156
; 		else if (speed <= -4)
	ldd 8,x
	cpd #-4
	bgt L60
	.dbline 158
; 		{
; 			L_Speed = -90;
	ldd #-90
	std 4,x
	.dbline 159
; 			R_Speed = 14;
	ldd #14
	std 2,x
	.dbline 160
; 		}
	jmp L57
L60:
	.dbline 161
; 		else if (speed <= -3)	
	ldd 8,x
	cpd #-3
	bgt L62
	.dbline 163
; 		{
; 			L_Speed = -80;
	ldd #-80
	std 4,x
	.dbline 164
; 			R_Speed = 24;
	ldd #24
	std 2,x
	.dbline 166
; 			//perfect
; 		}
	jmp L57
L62:
	.dbline 167
; 		else if (speed <= -2)
	ldd 8,x
	cpd #-2
	bgt L64
	.dbline 169
; 		{
; 			L_Speed = -70;
	ldd #-70
	std 4,x
	.dbline 170
; 			R_Speed = 34;
	ldd #34
	std 2,x
	.dbline 172
; 			//near perfect
; 		}
	jmp L57
L64:
	.dbline 173
; 		else if (speed <= -1)
	ldd 8,x
	cpd #-1
	bgt L66
	.dbline 175
; 		{
; 			L_Speed = -62;
	ldd #-62
	std 4,x
	.dbline 176
; 			R_Speed = 44;
	ldd #44
	std 2,x
	.dbline 177
; 		}
	jmp L57
L66:
	.dbline 178
; 		else if (speed <= 0)
	ldd 8,x
	ble X1
	jmp L57
X1:
	.dbline 180
; 		{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 181
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 183
; 		}
; 	}
	jmp L57
L56:
	.dbline 184
; 	else if (speed > 0)
	ldd 8,x
	bgt X2
	jmp L70
X2:
	.dbline 186
; 	{
; 		if (speed >= 5)
	ldd 8,x
	cpd #5
	blt L72
	.dbline 188
; 		{
; 			L_Speed = -6;
	ldd #-6
	std 4,x
	.dbline 189
; 			R_Speed = 99;
	ldd #99
	std 2,x
	.dbline 190
; 		}
	bra L71
L72:
	.dbline 191
; 		else if (speed >= 4)
	ldd 8,x
	cpd #4
	blt L74
	.dbline 193
; 		{
; 			L_Speed = -11;
	ldd #-11
	std 4,x
	.dbline 194
; 			R_Speed = 94;
	ldd #94
	std 2,x
	.dbline 195
; 		}
	bra L71
L74:
	.dbline 196
; 		else if (speed >= 3)
	ldd 8,x
	cpd #3
	blt L76
	.dbline 198
; 		{
; 			L_Speed = -19;
	ldd #-19
	std 4,x
	.dbline 199
; 			R_Speed = 84;
	ldd #84
	std 2,x
	.dbline 200
; 		}
	bra L71
L76:
	.dbline 201
; 		else if (speed >= 2)
	ldd 8,x
	cpd #2
	blt L78
	.dbline 203
; 		{
; 			L_Speed = -29;
	ldd #-29
	std 4,x
	.dbline 204
; 			R_Speed = 74;
	ldd #74
	std 2,x
	.dbline 205
; 		}
	bra L71
L78:
	.dbline 206
; 		else if (speed >= 1)
	ldd 8,x
	cpd #1
	blt L71
	.dbline 208
; 		{
; 			L_Speed = -41;
	ldd #-41
	std 4,x
	.dbline 209
; 			R_Speed = 64;
	ldd #64
	std 2,x
	.dbline 212
; 		}
; 		
; 	}
	bra L71
L70:
	.dbline 215
; 	else
; 	{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 216
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 217
; 	}		
L71:
L57:
	.dbline 221
; 
; 	
; 	
; 	if (speed < current_speed)
	ldd 8,x
	cpd _current_speed
	bge L82
	.dbline 223
; 	{
; 		BrakeLight;
	ldab #15
	stab 0x6000
	.dbline 224
; 	}
	bra L83
L82:
	.dbline 226
; 	else 
; 		NoSignal;
	ldab #11
	stab 0x6000
L83:
	.dbline 228
; 		
; 	motorp(0, L_Speed);
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 229
; 	motorp(1, R_Speed);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 231
; 
; 	return current_speed;
	ldd _current_speed
L55:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	puly
	rts
	.area bss
_velocity::
	.blkb 2
_i::
	.blkb 2
_yy::
	.blkb 2
_xx::
	.blkb 2
_d_of_turn::
	.blkb 2
_turning_IR::
	.blkb 2
_irR::
	.blkb 2
_irL::
	.blkb 2
_spd_factorR::
	.blkb 2
_spd_factorL::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
