	.module track_g4.c
	.dbfile track_g4.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; #include <transam.h>
; #include <stdio.h>
; 
; void off_track();
; void on_track();
; int IR_procT();
; int CDS_procT();
; int Accelerator(int);
; void turn(int);
; void turn_toward_ir();
; 
; int on_track_yes = 0;
; int current_lane = 0;
; int current_speed = 0;
; int velocity, i, j, k;
; int H_nose_min, H_L_min, H_R_min;
; int L_nose_min, L_L_min, L_R_min;
; int left_temp;
; int right_temp;
; int nosej;
; 
; H_L_min = 220;
; H_R_min = 180;
; H_nose_min = 170;
; 
; L_L_min = 200;
; L_R_min = 175;
; L_nose_min = 165;
; 
; void main(void)
; {
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_servotjp();
; 	
; 	NoSignal;
; 	START;
; 	IRE_ON;
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 	while(1)
; 	{
; 		//printf("\n%d", on_track_yes);	
; 		if (on_track_yes > 0)
; 		{
; 			on_track();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 		}
; 		else 
; 			off_track();
; 	
; 	}
; }
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; 
; void on_track()
; {
; 	int temptrack, z, noseO, left_cdsO, right_cdsO;
; 	int avoidance_ir;
; 
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 	noseO 		= analog(1);
; 	left_cdsO 	= analog(5);
; 	right_cdsO	= analog(6);
; 	
; 	temptrack = CDS_procT();
; 	turn(temptrack);
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 	velocity = Accelerator(-3);
; 	
; 	if ((noseO <= 150) && (left_cdsO <= 170) && (right_cdsO <= 160))
; 	{
; 		z++;
; 	}
; 	else if ((noseO >= 170) || (left_cdsO >= 175) || (right_cdsO >= 165))
; 	{
; 		z = 0;
; 	}
; 	
; 	if (z >= 10)
; 	{
; 		on_track_yes = 0;
; 	}
; 	
; 	avoidance_ir = IR_procT();
; 	
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	if ((avoidance_ir > 2) || (avoidance_ir < -2))
; 	{
; 		if (current_lane == 1)
; 		{
; 			turn(3);
; 			wait(350);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 			on_track_yes = 0;
; 		}
; 		else if (current_lane == 2)
; 		{
; 			turn(-3);
; 			wait(350);
; 			on_track_yes = 0;
; 		}
; 	
; 	}
; 	
; 	
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; }
; 
; 
; void off_track()
; {
; 	int turning_IR, nose, left_cds, right_cds;
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	
; 	turning_IR = IR_procT();
; 	turn(turning_IR);
; 	velocity = Accelerator(-2);
; 	current_lane = 0;
; 	
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 	if (FRONT_BUMP)
; 	{
; 		Accelerator(4);
; 		turn_toward_ir();
; 		wait(800);
; 	}
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 	
; 	nose 		= analog(1);
; 	left_cds 	= analog(5);
; 	right_cds	= analog(6);
; 		
; 	
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; if (nose > 190)
; {
; 
; 	Accelerator(-1);
; 	
; 	for ( i = 0; i < 3000; i++)
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	{
; 	left_temp = analog(5);
; 	right_temp = analog(6);
; 	
; 	
; 	if (left_temp > 190)
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 	{
; 		wait(200);
; 		break;
; 		j = 0;
; 		nosej = analog(1);
; 		while (( nosej <= 190) && ( j <= 2500))
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 		{
; 		nosej = analog(1);
; 		turn(3);
; 		j++;
; 		}
; 		if (nosej >= 190)
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 		{
; 			on_track_yes = 1;
; 		}
; 	
; 	
; 	
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_on_track_yes::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_lane::
	.blkb 2
	.area idata
	.word 0
	.area data
_current_speed::
	.blkb 2
	.area idata
	.word 0
	.area data
_H_L_min::
	.blkb 2
	.area idata
	.word 220
	.area data
_H_R_min::
	.blkb 2
	.area idata
	.word 180
	.area data
_H_nose_min::
	.blkb 2
	.area idata
	.word 170
	.area data
_L_L_min::
	.blkb 2
	.area idata
	.word 200
	.area data
_L_R_min::
	.blkb 2
	.area idata
	.word 175
	.area data
_L_nose_min::
	.blkb 2
	.area idata
	.word 165
	.area text
;  IX -> 0,x
_main::
	.dbfile track_g4.c
	.dbfunc main
	.dbline 33
	jsr _init_analog
	.dbline 34
	jsr _init_motortjp
	.dbline 35
	jsr _init_clocktjp
	.dbline 36
	jsr _init_servotjp
	.dbline 38
	ldab #11
	stab 0x6000
L20:
	.dbline 39
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 40
	ldab #7
	stab 0x7000
	bra L24
L23:
	.dbline 45
	ldd _on_track_yes
	ble L26
	.dbline 47
	jsr _on_track
	.dbline 48
	bra L27
L26:
	.dbline 50
	jsr _off_track
L27:
	.dbline 52
L24:
	.dbline 42
	bra L23
L19:
	rts
;  IX -> 0,x
;              z -> 2,x
;      temptrack -> 4,x
;     right_cdsO -> 6,x
;      left_cdsO -> 8,x
;          noseO -> 10,x
;   avoidance_ir -> 12,x
_on_track::
	jsr __enterb
	.byte 0xe
	.dbfunc on_track
	.dbline 60
	ldd #1
	jsr _analog
	std 10,x
	.dbline 61
	ldd #5
	jsr _analog
	std 8,x
	.dbline 62
	ldd #6
	jsr _analog
	std 6,x
	.dbline 64
	jsr _CDS_procT
	std 4,x
	.dbline 65
	ldd 4,x
	jsr _turn
	.dbline 66
	ldd #-3
	jsr _Accelerator
	std _velocity
	.dbline 68
	ldd 10,x
	cpd #150
	bgt L29
	ldd 8,x
	cpd #170
	bgt L29
	ldd 6,x
	cpd #160
	bgt L29
	.dbline 70
	ldd 2,x
	addd #1
	std 2,x
	.dbline 71
	bra L30
L29:
	.dbline 72
	ldd 10,x
	cpd #170
	bge L34
	ldd 8,x
	cpd #175
	bge L34
	ldd 6,x
	cpd #165
	blt L31
L34:
	.dbline 74
	ldd #0
	std 2,x
	.dbline 75
L31:
L30:
	.dbline 77
	ldd 2,x
	cpd #10
	blt L35
	.dbline 79
	ldd #0
	std _on_track_yes
	.dbline 80
L35:
	.dbline 82
	jsr _IR_procT
	std 12,x
	.dbline 84
	ldd 12,x
	cpd #2
	bgt L39
	ldd 12,x
	cpd #-2
	bge L37
L39:
	.dbline 86
	ldd _current_lane
	cpd #1
	bne L40
	.dbline 88
	ldd #3
	jsr _turn
	.dbline 89
	ldd #350
	jsr _wait
	.dbline 90
	ldd #0
	std _on_track_yes
	.dbline 91
	bra L41
L40:
	.dbline 92
	ldd _current_lane
	cpd #2
	bne L42
	.dbline 94
	ldd #-3
	jsr _turn
	.dbline 95
	ldd #350
	jsr _wait
	.dbline 96
	ldd #0
	std _on_track_yes
	.dbline 97
L42:
L41:
	.dbline 99
L37:
	.dbline 102
L28:
	xgdx
	addd #14
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;  func temp: 2,x - 4,x
;      right_cds -> 4,x
;       left_cds -> 6,x
;           nose -> 8,x
;     turning_IR -> 10,x
_off_track::
	jsr __enterb
	.byte 0xc
	.dbfunc off_track
	.dbline 109
	jsr _IR_procT
	std 10,x
	.dbline 110
	ldd 10,x
	jsr _turn
	.dbline 111
	ldd #-2
	jsr _Accelerator
	std _velocity
	.dbline 112
	ldd #0
	std _current_lane
	.dbline 114
	ldd #0
	jsr _analog
	cpd #10
	ble L45
	ldd #0
	jsr _analog
	cpd #120
	bge L45
	.dbline 116
	ldd #4
	jsr _Accelerator
	.dbline 117
	jsr _turn_toward_ir
	.dbline 118
	ldd #800
	jsr _wait
	.dbline 119
L45:
	.dbline 121
	ldd #1
	jsr _analog
	std 8,x
	.dbline 122
	ldd #5
	jsr _analog
	std 6,x
	.dbline 123
	ldd #6
	jsr _analog
	std 4,x
	.dbline 126
	ldd 8,x
	cpd #190
	ble L47
	.dbline 129
	ldd #-1
	jsr _Accelerator
	.dbline 131
	ldd #0
	std _i
L49:
	.dbline 133
	ldd #5
	jsr _analog
	std _left_temp
	.dbline 134
	ldd #6
	jsr _analog
	std _right_temp
	.dbline 137
	ldd _left_temp
	cpd #190
	ble L53
	.dbline 139
	ldd #200
	jsr _wait
	.dbline 140
	bra L51
L55:
	.dbline 145
	ldd #1
	jsr _analog
	std _nosej
	.dbline 146
	ldd #3
	jsr _turn
	.dbline 147
	ldd _j
	addd #1
	std _j
	.dbline 148
L56:
	.dbline 143
	ldd _nosej
	cpd #190
	bgt L58
	ldd _j
	cpd #2500
	ble L55
L58:
	.dbline 149
	ldd _nosej
	cpd #190
	blt L59
	.dbline 151
	ldd #1
	std _on_track_yes
	.dbline 152
L59:
	.dbline 156
; 	}
L53:
	.dbline 157
; }
L50:
	ldd _i
	addd #1
	std _i
	cpd #3000
	blt L49
L51:
	.dbline 158
; }
L47:
	.dbline 159
; }
L44:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         C_nose -> 2,x
;        C_right -> 4,x
;         C_left -> 6,x
;            XYZ -> 8,x
_CDS_procT::
	jsr __enterb
	.byte 0xa
	.dbfunc CDS_procT
	.dbline 166
; 	
; int CDS_procT()
; {
; 
; 	int C_left, C_right, C_nose, XYZ;
; 		
; 	C_left 	= analog(5);
	ldd #5
	jsr _analog
	std 6,x
	.dbline 167
; 	C_right  = analog(6);
	ldd #6
	jsr _analog
	std 4,x
	.dbline 168
; 	C_nose	= analog(1);
	ldd #1
	jsr _analog
	std 2,x
	.dbline 170
; 	
; 	XYZ = 0;
	ldd #0
	std 8,x
	.dbline 173
; 	
; 	//if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
; 	if ((C_left < L_L_min) && (C_right < L_R_min) && (C_nose < L_nose_min))
	ldd 6,x
	cpd _L_L_min
	bge L62
	ldd 4,x
	cpd _L_R_min
	bge L62
	ldd 2,x
	cpd _L_nose_min
	bge L62
	.dbline 175
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 176
; 	}
	bra L63
L62:
	.dbline 177
; 	else if (C_left > L_L_min)
	ldd 6,x
	cpd _L_L_min
	ble L64
	.dbline 179
; 	{
; 		XYZ = -3;
	ldd #-3
	std 8,x
	.dbline 180
; 	}
	bra L65
L64:
	.dbline 181
; 	else if (C_right > L_R_min)
	ldd 4,x
	cpd _L_R_min
	ble L66
	.dbline 183
; 	{
; 		XYZ = 3;
	ldd #3
	std 8,x
	.dbline 184
; 	}
	bra L67
L66:
	.dbline 185
; 	else if (C_nose > L_nose_min)
	ldd 2,x
	cpd _L_nose_min
	ble L68
	.dbline 187
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 188
; 	}
	bra L69
L68:
	.dbline 190
; 	//else if ((C_left < 225) && (C_right < 215))
; 	else if ((C_left < L_L_min) && (C_right < L_R_min))
	ldd 6,x
	cpd _L_L_min
	bge L70
	ldd 4,x
	cpd _L_R_min
	bge L70
	.dbline 192
; 	{
; 		XYZ = 0;
	ldd #0
	std 8,x
	.dbline 193
; 	}
L70:
L69:
L67:
L65:
L63:
	.dbline 195
; 	
; 	return XYZ;
	ldd 8,x
L61:
	xgdx
	addd #10
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         degree -> 2,x
;            dot -> 6,x
_turn::
	jsr __enterb
	.byte 0x44
	.dbfunc turn
	.dbline 202
; }
; 
; void turn(int dot)
; {
; 	int degree;
; 	
; 	if (dot < 0)
	ldd 6,x
	bge L73
	.dbline 204
; 	{
; 		if (dot <= -3)
	ldd 6,x
	cpd #-3
	bgt L75
	.dbline 206
; 		{
; 			degree = 1500;
	ldd #1500
	std 2,x
	.dbline 207
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 209
; 			
; 		}
	jmp L74
L75:
	.dbline 210
; 		else if (dot <= -2)
	ldd 6,x
	cpd #-2
	bgt L77
	.dbline 212
; 		{
; 			degree = 1834;
	ldd #1834
	std 2,x
	.dbline 213
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 215
; 			
; 		}
	bra L74
L77:
	.dbline 216
; 		else if (dot <= -1)
	ldd 6,x
	cpd #-1
	bgt L74
	.dbline 218
; 		{
; 			degree = 2167;
	ldd #2167
	std 2,x
	.dbline 219
; 			LeftSignal;
	ldab #1
	stab 0x6000
	.dbline 222
; 			
; 		}
; 	}
	bra L74
L73:
	.dbline 223
; 	else if (dot > 0)
	ldd 6,x
	ble L81
	.dbline 225
; 	{
; 		if (dot >= 3)
	ldd 6,x
	cpd #3
	blt L83
	.dbline 227
; 		{
; 			degree = 4000;
	ldd #4000
	std 2,x
	.dbline 228
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 230
; 			
; 		}
	bra L82
L83:
	.dbline 231
; 		else if (dot >= 2)
	ldd 6,x
	cpd #2
	blt L85
	.dbline 233
; 		{
; 			degree = 3500;
	ldd #3500
	std 2,x
	.dbline 234
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 236
; 			
; 		}
	bra L82
L85:
	.dbline 237
; 		else if (dot >= 1)
	ldd 6,x
	cpd #1
	blt L82
	.dbline 239
; 		{
; 			degree = 3000;
	ldd #3000
	std 2,x
	.dbline 240
; 			RightSignal;
	ldab #2
	stab 0x6000
	.dbline 243
; 			
; 		}
; 	}
	bra L82
L81:
	.dbline 246
; 	else
; 	{
; 		degree = 2500;
	ldd #2500
	std 2,x
	.dbline 247
; 		NoSignal;
	ldab #11
	stab 0x6000
	.dbline 248
; 	}
L82:
L74:
	.dbline 250
; 	
; 	servo(0, degree);
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 251
; 	wait(100);	
	ldd #100
	jsr _wait
	.dbline 253
; 
; }	
L72:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         t_diff -> 2,x
;          irT_R -> 4,x
;          irT_L -> 6,x
;             tR -> 8,x
;             tL -> 10,x
_IR_procT::
	jsr __enterb
	.byte 0xc
	.dbfunc IR_procT
	.dbline 259
; 
; int IR_procT()
; {
; 
; int irT_L, irT_R, t_diff;
; int tL = 0;
	ldd #0
	std 10,x
	.dbline 260
; int tR = 0;
	ldd #0
	std 8,x
	.dbline 261
; irT_L = analog(3);
	ldd #3
	jsr _analog
	std 6,x
	.dbline 262
; irT_R = analog(2);
	ldd #2
	jsr _analog
	std 4,x
	.dbline 268
; 
; //printf("\t%d\n", irT_L);
; //printf("\t\t%d\n", irT_R);
; 
; 
; if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L90
	.dbline 270
; {
; 	if (irT_L > 95)
	ldd 6,x
	cpd #95
	ble L91
	.dbline 272
; 	{
; 		tL = 1;
	ldd #1
	std 10,x
	.dbline 273
; 		if (irT_L > 105)
	ldd 6,x
	cpd #105
	ble L91
	.dbline 275
; 		{
; 			tL = tL + 1;	
	ldd 10,x
	addd #1
	std 10,x
	.dbline 276
; 			if (irT_L > 115)
	ldd 6,x
	cpd #115
	ble L91
	.dbline 278
; 			{
; 				tL = tL + 1;
	ldd 10,x
	addd #1
	std 10,x
	.dbline 282
; 			}
; 		}
; 	}
; }
	bra L91
L90:
	.dbline 285
; else
; 	{
; 		tL = 0;
	ldd #0
	std 10,x
	.dbline 286
; 	}	
L91:
	.dbline 289
; 
; 
; if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L98
	.dbline 292
; {
; 
; 	if (irT_R > 95)
	ldd 4,x
	cpd #95
	ble L99
	.dbline 294
; 	{
; 		tR = 1;
	ldd #1
	std 8,x
	.dbline 295
; 		if (irT_R > 105)
	ldd 4,x
	cpd #105
	ble L99
	.dbline 297
; 		{
; 			tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 298
; 			if (irT_R > 115)
	ldd 4,x
	cpd #115
	ble L99
	.dbline 300
; 			{
; 				tR = tR + 1;
	ldd 8,x
	addd #1
	std 8,x
	.dbline 304
; 			}	
; 		}
; 	}
; }	
	bra L99
L98:
	.dbline 307
; else 
; 	{
; 		tR = 0;
	ldd #0
	std 8,x
	.dbline 308
; 	}	
L99:
	.dbline 310
; 
; t_diff = tL - tR;
	ldd 10,x
	subd 8,x
	std 2,x
	.dbline 319
; 
; //printf ("\ntL=%d\t", tL);
; //printf ("tR=%d\t", tR);
; //printf ("t_diff=%d", t_diff);
; 
; //if ( tL = tR )
; //	return tR;
; //else 
; 	return t_diff;
	ldd 2,x
L89:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;        R_Speed -> 2,x
;        L_Speed -> 4,x
;          speed -> 8,x
_Accelerator::
	jsr __enterb
	.byte 0x46
	.dbfunc Accelerator
	.dbline 331
; 	
; }
; 
; 
; int Accelerator(int speed)
; {
; 	
; 	int L_Speed, R_Speed;
; 	 
; 	
; 	
; 	if (speed <= 0)
	ldd 8,x
	ble X0
	jmp L107
X0:
	.dbline 333
; 	{
; 		if (speed <= -5)
	ldd 8,x
	cpd #-5
	bgt L109
	.dbline 335
; 		{
; 			L_Speed = -99;
	ldd #-99
	std 4,x
	.dbline 336
; 			R_Speed = 4;
	ldd #4
	std 2,x
	.dbline 337
; 		}
	jmp L108
L109:
	.dbline 338
; 		else if (speed <= -4)
	ldd 8,x
	cpd #-4
	bgt L111
	.dbline 340
; 		{
; 			L_Speed = -90;
	ldd #-90
	std 4,x
	.dbline 341
; 			R_Speed = 14;
	ldd #14
	std 2,x
	.dbline 342
; 		}
	jmp L108
L111:
	.dbline 343
; 		else if (speed <= -3)	
	ldd 8,x
	cpd #-3
	bgt L113
	.dbline 345
; 		{
; 			L_Speed = -80;
	ldd #-80
	std 4,x
	.dbline 346
; 			R_Speed = 24;
	ldd #24
	std 2,x
	.dbline 348
; 			//perfect
; 		}
	jmp L108
L113:
	.dbline 349
; 		else if (speed <= -2)
	ldd 8,x
	cpd #-2
	bgt L115
	.dbline 351
; 		{
; 			L_Speed = -70;
	ldd #-70
	std 4,x
	.dbline 352
; 			R_Speed = 34;
	ldd #34
	std 2,x
	.dbline 354
; 			//near perfect
; 		}
	jmp L108
L115:
	.dbline 355
; 		else if (speed <= -1)
	ldd 8,x
	cpd #-1
	bgt L117
	.dbline 357
; 		{
; 			L_Speed = -62;
	ldd #-62
	std 4,x
	.dbline 358
; 			R_Speed = 44;
	ldd #44
	std 2,x
	.dbline 359
; 		}
	jmp L108
L117:
	.dbline 360
; 		else if (speed <= 0)
	ldd 8,x
	ble X1
	jmp L108
X1:
	.dbline 362
; 		{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 363
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 365
; 		}
; 	}
	jmp L108
L107:
	.dbline 366
; 	else if (speed > 0)
	ldd 8,x
	bgt X2
	jmp L121
X2:
	.dbline 368
; 	{
; 		if (speed >= 5)
	ldd 8,x
	cpd #5
	blt L123
	.dbline 370
; 		{
; 			L_Speed = -6;
	ldd #-6
	std 4,x
	.dbline 371
; 			R_Speed = 99;
	ldd #99
	std 2,x
	.dbline 372
; 		}
	bra L122
L123:
	.dbline 373
; 		else if (speed >= 4)
	ldd 8,x
	cpd #4
	blt L125
	.dbline 375
; 		{
; 			L_Speed = -11;
	ldd #-11
	std 4,x
	.dbline 376
; 			R_Speed = 94;
	ldd #94
	std 2,x
	.dbline 377
; 		}
	bra L122
L125:
	.dbline 378
; 		else if (speed >= 3)
	ldd 8,x
	cpd #3
	blt L127
	.dbline 380
; 		{
; 			L_Speed = -19;
	ldd #-19
	std 4,x
	.dbline 381
; 			R_Speed = 84;
	ldd #84
	std 2,x
	.dbline 382
; 		}
	bra L122
L127:
	.dbline 383
; 		else if (speed >= 2)
	ldd 8,x
	cpd #2
	blt L129
	.dbline 385
; 		{
; 			L_Speed = -29;
	ldd #-29
	std 4,x
	.dbline 386
; 			R_Speed = 74;
	ldd #74
	std 2,x
	.dbline 387
; 		}
	bra L122
L129:
	.dbline 388
; 		else if (speed >= 1)
	ldd 8,x
	cpd #1
	blt L122
	.dbline 390
; 		{
; 			L_Speed = -41;
	ldd #-41
	std 4,x
	.dbline 391
; 			R_Speed = 64;
	ldd #64
	std 2,x
	.dbline 394
; 		}
; 		
; 	}
	bra L122
L121:
	.dbline 397
; 	else
; 	{
; 			L_Speed = 0;
	ldd #0
	std 4,x
	.dbline 398
; 			R_Speed = 0;
	ldd #0
	std 2,x
	.dbline 399
; 	}		
L122:
L108:
	.dbline 403
; 
; 	
; 	
; 	if (speed < current_speed)
	ldd 8,x
	cpd _current_speed
	bge L133
	.dbline 405
; 	{
; 		BrakeLight;
	ldab #15
	stab 0x6000
	.dbline 406
; 	}
	bra L134
L133:
	.dbline 408
; 	else 
; 		NoSignal;
	ldab #11
	stab 0x6000
L134:
	.dbline 410
; 		
; 	motorp(0, L_Speed);
	ldd 4,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 411
;    motorp(1, R_Speed);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 413
; 
; 	return current_speed;
	ldd _current_speed
L106:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;         temp_R -> 2,x
;         temp_L -> 4,x
_turn_toward_ir::
	jsr __enterb
	.byte 0x6
	.dbfunc turn_toward_ir
	.dbline 423
; }
; 
; 
; void turn_toward_ir()
; {
; 
; 	int temp_L;
; 	int temp_R;
; 	
; 	temp_L = analog(3);
	ldd #3
	jsr _analog
	std 4,x
	.dbline 424
; 	temp_R = analog(2);
	ldd #2
	jsr _analog
	std 2,x
	.dbline 426
; 
; 	if (temp_L > temp_R)
	ldd 4,x
	cpd 2,x
	ble L136
	.dbline 428
; 		{
; 			turn(-3);
	ldd #-3
	jsr _turn
	.dbline 430
; 			//printf("-3");
; 		}
	bra L137
L136:
	.dbline 431
; 	else if (temp_R > temp_L)
	ldd 2,x
	cpd 4,x
	ble L138
	.dbline 433
; 		{
; 			turn(3);
	ldd #3
	jsr _turn
	.dbline 435
; 			//printf("3");
; 		}
L138:
L137:
	.dbline 437
; 	
; }
L135:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
	.area bss
_nosej::
	.blkb 2
_right_temp::
	.blkb 2
_left_temp::
	.blkb 2
_k::
	.blkb 2
_j::
	.blkb 2
_i::
	.blkb 2
_velocity::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
