	.module t_analog.c
	.dbfile t_analog.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; #define DebugSW		analog(7)
; #define CDSnose		analog(1)
; #define CDS_L		analog(5)
; #define CDS_R		analog(6)
; #define Nose_IR		analog(4)
; 
; int IR_processor();
; int temp1;
; 
; /***************************** Main **********************************/
; void main(void)
; {
; 
; /* VT100 clear screen */ 
;   char clear[]= "\x1b\x5B\x32\x4A\x04"; 
; 
; /* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
;   char place[]= "\x1b[1;1H";	/*Home*/	
; 
;   init_analog();
;   init_clocktjp();
;   init_serial();
; 
;   IRE_ON; /*turn on IR emitters */
; 
;   printf("%s", clear);  
;   printf("%s", place);
;   
;   printf("\tTitle\t\t_analog.c\n"
;   "\tProgrammer\tJason Grzywna\n"
;   "\tDate\t\tMarch, 2000\n"
;   "\tVersion\t\t1.0\n\n");
; 
;   printf("TRANS AM SENSOR READINGS\n\n");
;   printf("Left IR    Right IR    Bumper    Nose_IR    CDSnose    CDS_L    CDS_R\n"); 
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 		
; 
;   while(1)
;   {
; 	//temp1 = IR_processor();
;   /*
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
;     Move cursor to data field position and print data
;     The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
;   */
;     printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
;     printf("\x1b[10;13H   \b\b\b\b%d",RIGHT_IR);
;     printf("\x1b[10;25H   \b\b\b\b%d",BUMPER);
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
;     printf("\x1b[10;36H   \b\b\b\b%d",Nose_IR);
;     printf("\x1b[10;47H   \b\b\b\b%d",CDSnose);
;     printf("\x1b[10;58H   \b\b\b\b%d",CDS_L);
;     printf("\x1b[10;69H   \b\b\b\b%d",CDS_R);
;     //printf("\x1b[10;78H   \b\b\b\b%d\n\n\n\n",temp1);
;     wait(50);
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 
;   }/*end while(1)*/
; }
; /***************************** End of Main **********************************/
; int IR_processor(void)
; {
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
; 	int IRout, IRout1, IRtemp, irLtemp, irRtemp, irL, irR;
; 		
; 	irL = analog(3);
; 	irR = analog(2);
; 	
; 	
; 	printf("\nIR Left - %d", irL);
; 	printf("\nIR Right - %d", irR);
; 		irLtemp = -irL;
; 		irRtemp = irR;
; 		IRtemp = (irLtemp + irRtemp);
; 
; 	
; 	/*IRout1 = (IRtemp * 2.5);
; 	printf("\nIRout1 - %d", IRout1);*/ 				/* Scales to -100 -> 100 */
; 		
; 	if ((IRtemp < 12) && (IRtemp > -12)) /* || (IRtemp = 0))		/* Processes Depth is object is centered */		
; 	{ 
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 		if ((irL < 95) && (irR < 95))
; 		{
; 			IRout = 11;
; 		}
; 		else if ((irL < 105) && (irR < 105))
; 		{
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 			IRout = 22;
; 		}
; 		else if ((irL < 115) && (irR < 115))
; 		{
; 			IRout = 33;
; 		}
; 		else if ((irL < 124) && (irR < 124))
; 		{
; 			IRout = 44;
; 		}
; 		else if ((irL > 125) && (irR > 125))
; 		{
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; 			IRout = 55;
; 			printf("CLOSE");
; 		}
; 	}
; 	else
; 	{
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 		IRout = IRtemp; /*(IRout1 / 10);*/
; 		printf("\n\nIRout!!! - %d", IRout);
; 	}
; 		
; 	
; 	return IRout;
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
L20:
	.byte 27,91,50,'J,4,0
L21:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;          place -> 3,x
;          clear -> 10,x
_main::
	jsr __enterb
	.byte 0x10
	.dbfile t_analog.c
	.dbfunc main
	.dbline 21
	ldd 0,x
	addd #10
	ldy #L20
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 24
	ldd 0,x
	addd #3
	ldy #L21
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 26
	jsr _init_analog
	.dbline 27
	jsr _init_clocktjp
	.dbline 28
	jsr _init_serial
	.dbline 30
	ldab #7
	stab 0x7000
	.dbline 32
	ldd 0,x
	addd #10
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 33
	ldd 0,x
	addd #3
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 35
	ldd #L23
	jsr _printf
	.dbline 40
	ldd #L24
	jsr _printf
	.dbline 41
	ldd #L25
	jsr _printf
	bra L27
L26:
	.dbline 51
	ldd #3
	jsr _analog
	pshb
	psha
	ldd #L29
	jsr _printf
	puly
	.dbline 52
	ldd #2
	jsr _analog
	pshb
	psha
	ldd #L30
	jsr _printf
	puly
	.dbline 53
	ldd #0
	jsr _analog
	pshb
	psha
	ldd #L31
	jsr _printf
	puly
	.dbline 54
	ldd #4
	jsr _analog
	pshb
	psha
	ldd #L32
	jsr _printf
	puly
	.dbline 55
	ldd #1
	jsr _analog
	pshb
	psha
	ldd #L33
	jsr _printf
	puly
	.dbline 56
	ldd #5
	jsr _analog
	pshb
	psha
	ldd #L34
	jsr _printf
	puly
	.dbline 57
	ldd #6
	jsr _analog
	pshb
	psha
	ldd #L35
	jsr _printf
	puly
	.dbline 59
	ldd #50
	jsr _wait
	.dbline 61
L27:
	.dbline 44
	bra L26
L19:
	xgdx
	addd #16
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;         IRout1 -> 2,x
;        irRtemp -> 4,x
;        irLtemp -> 6,x
;          IRout -> 8,x
;         IRtemp -> 10,x
;            irR -> 12,x
;            irL -> 14,x
_IR_processor::
	jsr __enterb
	.byte 0x10
	.dbfunc IR_processor
	.dbline 68
	ldd #3
	jsr _analog
	std 14,x
	.dbline 69
	ldd #2
	jsr _analog
	std 12,x
	.dbline 72
	ldd 14,x
	pshb
	psha
	ldd #L37
	jsr _printf
	puly
	.dbline 73
	ldd 12,x
	pshb
	psha
	ldd #L38
	jsr _printf
	puly
	.dbline 74
	ldd 14,x
	nega
	negb
	sbca #0
	std 6,x
	.dbline 75
	ldd 12,x
	std 4,x
	.dbline 76
	ldd 6,x
	addd 4,x
	std 10,x
	.dbline 82
	ldd 10,x
	cpd #12
	blt X0
	jmp L39
X0:
	ldd 10,x
	cpd #-12
	bgt X1
	jmp L39
X1:
	.dbline 84
	ldd 14,x
	cpd #95
	bge L41
	ldd 12,x
	cpd #95
	bge L41
	.dbline 86
	ldd #11
	std 8,x
	.dbline 87
	jmp L40
L41:
	.dbline 88
	ldd 14,x
	cpd #105
	bge L43
	ldd 12,x
	cpd #105
	bge L43
	.dbline 90
	ldd #22
	std 8,x
	.dbline 91
	bra L40
L43:
	.dbline 92
	ldd 14,x
	cpd #115
	bge L45
	ldd 12,x
	cpd #115
	bge L45
	.dbline 94
	ldd #33
	std 8,x
	.dbline 95
	bra L40
L45:
	.dbline 96
	ldd 14,x
	cpd #124
	bge L47
	ldd 12,x
	cpd #124
	bge L47
	.dbline 98
	ldd #44
	std 8,x
	.dbline 99
	bra L40
L47:
	.dbline 100
	ldd 14,x
	cpd #125
	ble L40
	ldd 12,x
	cpd #125
	ble L40
	.dbline 102
	ldd #55
	std 8,x
	.dbline 103
	ldd #L51
	jsr _printf
	.dbline 105
	bra L40
L39:
	.dbline 108
	ldd 10,x
	std 8,x
	.dbline 109
	ldd 8,x
	pshb
	psha
	ldd #L52
	jsr _printf
	puly
	.dbline 110
L40:
	.dbline 113
	ldd 8,x
L36:
	xgdx
	addd #16
	xgdx
	txs
	pulx
	rts
	.area bss
_temp1::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L52:
	.byte 10,10,'I,'R,'o,'u,'t,33,33,33,32,45,32,37,'d,0
L51:
	.byte 'C,'L,'O,'S,'E,0
L38:
	.byte 10,'I,'R,32,'R,'i,'g,'h,'t,32,45,32,37,'d,0
L37:
	.byte 10,'I,'R,32,'L,'e,'f,'t,32,45,32,37,'d,0
L35:
	.byte 27,91,49,48,59,54,57,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L34:
	.byte 27,91,49,48,59,53,56,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L33:
	.byte 27,91,49,48,59,52,55,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L32:
	.byte 27,91,49,48,59,51,54,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L31:
	.byte 27,91,49,48,59,50,53,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L30:
	.byte 27,91,49,48,59,49,51,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L29:
	.byte 27,91,49,48,59,49,'H,32,32,32,32,8,8,8,8,8
	.byte 37,'d,0
L25:
	.byte 'L,'e,'f,'t,32,'I,'R,32,32,32,32,'R,'i,'g,'h,'t
	.byte 32,'I,'R,32,32,32,32,'B,'u,'m,'p,'e,'r,32,32,32
	.byte 32,'N,'o,'s,'e,95,'I,'R,32,32,32,32,'C,'D,'S,'n
	.byte 'o,'s,'e,32,32,32,32,'C,'D,'S,95,'L,32,32,32,32
	.byte 'C,'D,'S,95,'R,10,0
L24:
	.byte 'T,'R,'A,'N,'S,32,'A,'M,32,'S,'E,'N,'S,'O,'R,32
	.byte 'R,'E,'A,'D,'I,'N,'G,'S,10,10,0
L23:
	.byte 9,'T,'i,'t,'l,'e,9,9,95,'a,'n,'a,'l,'o,'g,46
	.byte 'c,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9,'J,'a
	.byte 's,'o,'n,32,'G,'r,'z,'y,'w,'n,'a,10,9,'D,'a,'t
	.byte 'e,9,9,'M,'a,'r,'c,'h,44,32,50,48,48,48,10,9
	.byte 'V,'e,'r,'s,'i,'o,'n,9,9,49,46,48,10,10,0
L22:
	.byte 37,'s,0
