#include <analog.h>
#include <clocktjp.h>
#include <motortjp.h>
#include <servotjp.h>
#include <serialtp.h>
#include <isrdecl.h>
#include <vectors.h>


#define START 		while(BUMPER<120)
#define LIGHTS_PORT	*(unsigned char *)(0x6000)
#define DebugSW		analog(7)
#define CDSnose		analog(1)
#define CDS_L		analog(5)
#define CDS_R		analog(6)
#define BUMPER   	analog(0)

#define LeftSignal	LIGHTS_PORT = 0x01
#define RightSignal	LIGHTS_PORT = 0x02
#define HazardSignal	LIGHTS_PORT = 0x03
#define BrakeLight	LIGHTS_PORT = 0x0F  
#define NoSignal	LIGHTS_PORT = 0x0B

/* Enable OC4 interrupt and all servo operations */
#define SERVOS_ON     SET_BIT(TMSK1,0x10)             

/*Disable OC4 interrupt: Stops all servo holding torques, useful for energy savings*/
#define SERVOS_OFF    CLEAR_BIT(TMSK1, 0x10)

#define IRE_ON  *(unsigned char *)(0x7000) = 0x07
#define IRE_OFF	*(unsigned char *)(0x7000) = 0x00

#define FRONT_BUMP  (BUMPER>10)&&(BUMPER< 120)
#define BACK_BUMP   BUMPER>120
